function _retry(func, ...)
 local ret = false
 local first = true
 repeat
  ret = func(first, ...)
  first = false
  if (ret == nil) then
   coroutine.yield()
  end
 until ret ~= nil
 return ret
end
function subBeforeDemo()
 BattleGauge( 0 )
 PauseLimitTime( 1 )
 ShowTimedArk( 0 )
 DeleteText()
 Tune( 0 )
end
function subAfterDemo()
 BattleGauge( 1 )
 PauseLimitTime( 0 )
 ShowTimedArk( 1 )
 Tune( 1 )
end
function subTextTutorial( tutorial, t_begin, t_end, state )
 if ( state == "WaitText" ) then
  _retry( WaitTime, 0.4 )
  DeleteText()
  _retry( WaitTime, 0.4 )
 end
 Special( "BLOCK_PAUSEMENU", 1 )
 if ( BeginDemo( 8 + 128 ) ) then
  PauseBattle( 1 )
  MusicVolume( 0.4 )
  ScreenColor( 1, 0.3, 0.5, 0.5, 0.5 )
  for i = t_begin, t_end do
   if table.maxn( tutorial[i] ) < 4 then
    table.insert( tutorial[i], "" )
   end
   CreateText( "【 " .. tutorial[i][2] .. " 】," .. tutorial[i][3], 3600, 1 )
   SePlay( "SEID_STG_HELP_TEXT_OPEN" )
   if ( tutorial[i][1] == "" or
     string.match( tutorial[i][4], "NoCreateArk" ) ) then
   else
    CreateArk( tutorial[i][1] )
   end
   _retry( WaitKeyPress, 1, 3600 )
   if ( tutorial[i][1] == "" or
     string.match( tutorial[i][4] ,"NoDeleteArk" ) ) then
   else
    DeleteArk( tutorial[i][1] )
   end
   DeleteText()
   SePlay( "SEID_STG_HELP_TEXT_CLOSE" )
   _retry( WaitTime, 0.1 )
  end
  PauseBattle( 0 )
  MusicVolume( 1.0 )
  ScreenColor( 0, 0.3, 0.5, 0.5, 0.5 )
  EndDemo()
 end
 _retry( WaitTime, 0.1 )
 DeleteText()
 Special( "BLOCK_PAUSEMENU", 0 )
end
function subTextTutorialInDemo( tutorial, num, state )
 if ( state == "LAST" ) then
 elseif ( state == "NoPause" ) then
  MusicVolume( 0.4 )
 else
  PauseBattle( 1 )
  MusicVolume( 0.4 )
 end
 CreateText( "【 " .. tutorial[num][2] .. " 】," .. tutorial[num][3], 3600, 1 )
 SePlay( "SEID_STG_HELP_TEXT_OPEN" )
 _retry( WaitKeyPress, 1, 3600 )
 DeleteText()
 SePlay( "SEID_STG_HELP_TEXT_CLOSE" )
 _retry( WaitTime, 0.1 )
 if ( state == "NEXT" ) then
 elseif ( state == "NoPause" ) then
  MusicVolume( 1.0 )
 else
  PauseBattle( 0 )
  MusicVolume( 1.0 )
 end
 _retry( WaitTime, 0.1 )
 DeleteText()
end
function subFadeOutIn()
 FadeOut( 1, 0, 1 )
 _retry( WaitTime, 1 )
 FadeIn( 0.4, 0, 1 )
end
function SetShadowPreset(preset_name)
 local shadow_blightness = 1.0
 if (preset_name == "MS_NEAR") then
  Special("SHADOW", shadow_blightness, 0, 35.0, 500.0)
 elseif (preset_name == "MS_MIDDLE") then
  Special("SHADOW", shadow_blightness, 0, 90.0, 500.0)
 elseif (preset_name == "MS_FAR") then
  Special("SHADOW", shadow_blightness, 0, 120.0, 500.0)
 elseif (preset_name == "BS_BACK") then
  Special("SHADOW", shadow_blightness, 1, 1200.0)
 elseif (preset_name == "BS_DIRECT") then
  Special("SHADOW", shadow_blightness * 0.5, 0, 1200.0, 1200.0)
 end
end
function subCutin( ci )
 local voice_num = table.maxn( ci.voice )
 local voice_one = 0
 if voice_num <= 1 then
  voice_one = ci.voice[1]
 else
  voice_one = ci.voice[ 1 + Rand( voice_num ) ]
 end
 if ci.obj == "KYUBEY" then
  ci.face = 0
 elseif string.match( ci.obj, "@MPR_" ) then
  ci.face = subFaceExpression( GetUnitInfo( ci.obj, 11 ), voice_one )
 else
  ci.face = subFaceExpression( ci.obj, voice_one )
 end
 if ci.obj == "@MPR_Player_1_0" then
  ci.pos = 0
 elseif ci.obj == "@MPR_Player_2_0" then
  ci.pos = 1
 elseif ci.obj == "KYUBEY" then
  ci.pos = 2
 else
  ci.pos = 3
 end
  _retry( EQFace, ci.obj, ci.face, ci.pos )
  _retry( EQWaitFace, ci.pos )
 if ci.shake ~= nil then
  _retry( EQShake2D, ci.obj, ci.shake[1], ci.shake[2] )
 end
 _retry( EQVoice, ci.obj, { voice_one } )
 _retry( EQWaitVoice )
 _retry( EQWaitTime, 0.3 )
end
function subFaceExpression( obj, voice )
 local puella = { "MADOKA", "SAYAKA", "MAMI", "HOMURA", "KYOKO" }
 if ( obj == "MEGAHOMU" ) then
  obj = "HOMURA"
 end
 for i = 1, table.maxn( puella ) do
  if string.match( obj, puella[i] ) then
   for j = 1, table.maxn( G_FACETYPE[i] ) do
    if G_FACETYPE[i][j][1] == voice then
     return G_FACETYPE[i][j][2]
    end
   end
  end
 end
 return 0
end
function subDeleteCutin()
 if CheckBusy() then
  _retry( EQDeleteFace )
  _retry( EQWaitTime, 1/30 )
 end
end
if ( string.match( GetSystemVar( -94 ), "s10" ) ) then
elseif ( string.match( GetSystemVar( -94 ), "s50" ) ) then
elseif ( string.match( GetSystemVar( -94 ), "s310" ) ) then
else
 AddEventTrigger( "TIMEUP_60", 740, "RESTSEC", 61 )
 AddEventTrigger( "TIMEUP_30", 730, "RESTSEC", 31 )
 AddEventTrigger( "TIMEUP_20", 720, "RESTSEC", 21 )
 AddEventTrigger( "TIMEUP_10", 710, "RESTSEC", 11 )
 AddEventTrigger( "TIMEUP_OVER", 1, "RESTSEC", 0 )
end
function TIMEUP_60()
 if ( subEQCheck(816) and GetUnitInfo( "@MPR_Player_1_0", 0 ) > 0 ) then
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  subCutin( { obj="@MPR_Player_1_0", voice={ 2100 } } )
  subDeleteCutin()
 end
 CreateArk( "ark_mission_time_alert" )
 SePlay( "SEID_STG_TIME_ANNOUNCE" )
 _retry( WaitTime, 5.0 )
 DeleteArk()
end
function TIMEUP_30()
 if not subMockCheck() then
  if subEQCheck(814) then
   if subWitchCheck() then
    subCutin( { obj="KYUBEY", voice={ 2130 } } )
   else
    subCutin( { obj="KYUBEY", voice={ 2120 } } )
   end
   subDeleteCutin()
  end
 end
 CreateArk( "ark_mission_time_alert" )
 SePlay( "SEID_STG_TIME_ANNOUNCE" )
 _retry( WaitTime, 5.0 )
 DeleteArk()
end
function TIMEUP_20()
 local talk = {}
 if ( subFriendship() >= 70 ) then
  if subMamiPlayer() then
   talk = { 2180 }
  else
   talk = { 2160 }
  end
 elseif ( subFriendship() >= 40 ) then
  if subMamiPlayer() then
   talk = { 2140 }
  else
   talk = { 2120 }
  end
 end
 if ( subEQCheck(812) and
   GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
   subFriendship() >= 40 ) then
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  subCutin( { obj="@MPR_Player_2_0", voice=talk } )
  subDeleteCutin()
 end
 CreateArk( "ark_mission_time_alert" )
 SePlay( "SEID_STG_TIME_PINCH" )
 _retry( WaitTime, 5.0 )
 DeleteArk()
end
function TIMEUP_10()
 local talk = {}
 if ( subFriendship() >= 70 ) then
  if subMamiPlayer() then
   talk = { 2190 }
  else
   talk = { 2170 }
  end
 elseif ( subFriendship() >= 40 ) then
  if subMamiPlayer() then
   talk = { 2150 }
  else
   talk = { 2130 }
  end
 end
 if subEQCheck(810) then
  if ( GetUnitInfo( "@MPR_Player_1_0", 0 ) > 0 ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 2110 } } )
  end
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
    subFriendship() >= 40 ) then
   subCutin( { obj="@MPR_Player_2_0", voice=talk } )
  end
  subDeleteCutin()
 end
 CreateArk( "ark_mission_time_alert" )
 SePlay( "SEID_STG_TIME_PINCH" )
 _retry( WaitTime, 5.0 )
 DeleteArk()
end
function TIMEUP_OVER()
 local p1 = GetUnitInfo( "@MPR_Player_1_0", 11 )
 local p2 = GetUnitInfo( "@MPR_Player_2_0", 11 )
 local talk = {}
 _retry( EQDelete )
 _retry( WaitTime, 1/30 )
 ResetTime()
 Special( "INVALIDATE_GIMMICK", 1 )
 BattleGauge( 0 )
 DeleteArk()
 DeleteTimedArk()
 PauseLimitTime( 1 )
 Special( "BLOCK_PAUSEMENU", 1 )
 Special( "UNBREAKABLE" )
 if ( BeginDemo( 16 ) ) then
  CreateArk( "ark_mission_time_over" )
  Music( -3 )
  SePlay( "SEID_STG_TIME_UP" )
  subCutin( { obj="@MPR_Player_1_0", voice={ 2200 } } )
  if ( GetUnitInfo( "@MPR_Player_2_0", 2 ) > 0 ) then
   if ( ( p1 == "MADOKA" and ( p2 == "SAYAKA" or p2 == "HOMURA" or p2 == "KYOKO" ) ) or
     ( p1 == "SAYAKA" and p2 == "MADOKA" ) or
     ( p1 == "MAMI" and p2 == "MADOKA" ) or
     ( p1 == "HOMURA" and p2 == "MADOKA" ) or
     ( p1 == "KYOKO" and p2 == "MADOKA" ) ) then
    talk = { 2200 }
   else
    talk = { 2210 }
   end
   subCutin( { obj="@MPR_Player_2_0", voice=talk } )
  else
   if not subMockCheck() then
    if subWitchCheck() then
     talk = { 2200 }
    else
     talk = { 2210 }
    end
    subCutin( { obj="KYUBEY", voice=talk } )
   end
  end
  subDeleteCutin()
  _retry( EQWait )
  _retry( WaitElapsedTime, 6 )
  DeleteArk()
  _retry( WaitArk )
 end
 Special( "BLOCK_PAUSEMENU", 0 )
 Special( "GAMEOVER" )
end
if string.match( GetSystemVar( -93 ), "s5" ) then
else
 AddEventTrigger( "PLAYER_IMMORTALITY", 11, "SOULGEM_EMPTY" )
end
function PLAYER_IMMORTALITY()
 local unit = { "@MPR_Player_1_0", "@MPR_Player_2_0" }
 local talk = {}
 if ( string.match( GetSystemVar( -94 ), "s10" ) or
   string.match( GetSystemVar( -94 ), "s310" ) ) then
  SetUnitInfo( unit[1], 1, 1 )
 end
 if subEQCheck(580) then
  if ( GetUnitInfo( unit[2], 0 ) <= 0 or
    subFriendship() < 40 ) then
   if ( Rand(2) < 1 or subMockCheck() or subPrologueCheck() ) then
    subCutin( { obj=unit[1], voice={ 1690, 1700 } } )
   else
    subCutin( { obj="KYUBEY", voice={ 1730, 1740 } } )
   end
  else
   if subMamiPlayer() then
    if ( subFriendship() < 70 ) then
     talk = { 1720 }
    else
     talk = { 1750, 1760 }
    end
   else
    if ( subFriendship() < 70 ) then
     talk = { 1710 }
    else
     talk = { 1730, 1740 }
    end
   end
   subCutin( { obj=unit[2], voice=talk } )
  end
  subDeleteCutin()
 end
end
if ( string.find( GetSystemVar( -94 ), "s10" ) == nil ) then
 AddEventTrigger( "GAME_OVER", 1, "GAMEOVER" )
end
function GAME_OVER()
 local unit = { "@MPR_Player_1_0", "@MPR_Player_2_0" }
 local unitid = { GetUnitInfo( unit[1], 11 ), GetUnitInfo( unit[2], 11 ) }
 PauseLimitTime( 1 )
 Special( "BLOCK_PAUSEMENU", 1 )
 Special( "UNBREAKABLE" )
 Special( "INVALIDATE_GIMMICK", 1 )
 subBeforeDemo()
 Music( -3 )
 _retry( EQDelete )
 _retry( WaitTime, 1/30 )
 subCutin( { obj=unit[1], voice={ 1130, 1140, 1150 },
    shake={ 12, 3 } } )
 if ( GetUnitInfo( unit[2], 0 ) > 0 ) then
  if ( subFriendship() >= 70 ) then
   if ( unitid[1] == "MADOKA" ) then
    talk = { 1340, 1350, 1380, 1380 }
   elseif ( unitid[1] == "SAYAKA" ) then
    talk = { 1340, 1350, 1390, 1390 }
   elseif ( unitid[1] == "MAMI" ) then
    if ( unitid[2] == "MADOKA" or
      unitid[2] == "SAYAKA" ) then
     talk = { 1360, 1370, 1400, 1400 }
    else
     talk = { 1340, 1350, 1400, 1400 }
    end
   elseif ( unitid[1] == "HOMURA" ) then
    talk = { 1340, 1350, 1410, 1410 }
   elseif ( unitid[1] == "KYOKO" ) then
    talk = { 1340, 1350, 1420, 1420 }
   end
  elseif ( ( unit[1] == "@MPR_Player_1_0" and subMamiPlayer() ) or
     ( unit[1] == "@MPR_Player_2_0" and subMamiPartner() ) ) then
   if ( subFriendship() >= 40 ) then
    talk = { 1330 }
   else
    talk = { 1310 }
   end
  else
   if ( subFriendship() >= 40 ) then
    talk = { 1320 }
   else
    talk = { 1300 }
   end
  end
  subCutin( { obj=unit[2], voice=talk } )
 elseif ( unitid[1] == "HOMURA" and not subMockCheck() ) then
  subCutin( { obj="KYUBEY", voice={ 1410 } } )
 end
 subDeleteCutin()
 _retry( WaitElapsedTime, 3 )
 _retry( EQWait )
 if ( BeginDemo( 1
               + 8
               + 16 ) ) then
  subBeforeDemo()
  SePlay( "SEID_STG_STAGE_FAILED" )
  CreateArk( "ark_mission_stage_failure" )
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT", unit[1], 0, 0, 0 )
  Path( 1, 2, "PARENT", unit[1],
     0, 0, 0,
     0.1, 15, 0.1,
     0, Rand(360), 0,
     0, 1.8, 0,
     0, -5, 0 )
  subCutin( { obj=unit[1], voice={ 2220, 2230 } } )
  if ( GetUnitInfo( unit[2], 11 ) ~= "" ) then
   subCutin( { obj=unit[2], voice={ 2220, 2230 } } )
  else
   if subMockCheck() then
   else
    subCutin( { obj="KYUBEY", voice={ 2220, 2230 } } )
   end
  end
  subDeleteCutin()
  _retry( EQWait )
  _retry( WaitElapsedTime, 5 )
  DeleteArk()
  _retry( WaitArk )
  Special( "BLOCK_PAUSEMENU", 0 )
  Special( "GAMEOVER" )
  EndDemo()
 end
end
AddEventTrigger( "PLAYER_REVIVESELF", 99, "REVIVE_SELF", "@MPR_Player_1_0" )
AddEventTrigger( "PARTNER_REVIVESELF", 99, "REVIVE_SELF", "@MPR_Player_2_0" )
AddEventTrigger( "PLAYER_REVIVEFRIEND", 99, "REVIVE_FRIEND", "@MPR_Player_1_0" )
AddEventTrigger( "PARTNER_REVIVEFRIEND",99, "REVIVE_FRIEND", "@MPR_Player_2_0" )
function PLAYER_REVIVESELF()
 if ( string.find( GetSystemVar( -94 ), "s10" ) ~= nil and
   GetUnitInfo( "@MPR_Player_1_0", 55 ) <= 0 ) then
  SetUnitInfo( "@MPR_Player_1_0", 1, 1 )
 end
 if subEQCheck(586) then
  subCutin( { obj="@MPR_Player_1_0", voice={ 1590, 1600 } } )
  subDeleteCutin()
 end
end
function PARTNER_REVIVESELF()
 if subEQCheck(588) then
  subCutin( { obj="@MPR_Player_2_0", voice={ 1590, 1600 } } )
  subDeleteCutin()
 end
end
function PLAYER_REVIVEFRIEND()
 local talk = {}
 if ( string.find( GetSystemVar( -94 ), "s10" ) ~= nil and
   GetUnitInfo( "@MPR_Player_1_0", 55 ) <= 0 ) then
  SetUnitInfo( "@MPR_Player_1_0", 1, 1 )
 end
 if subEQCheck(585) then
  if subMamiPlayer() then
   if ( subFriendship() < 40 ) then
    talk = { 1440 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1460 }
   else
    talk = { 1490, 1500 }
   end
  else
   if ( subFriendship() < 40 ) then
    talk = { 1430 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1450 }
   else
    talk = { 1470, 1480 }
   end
  end
  subCutin( { obj="@MPR_Player_2_0", voice=talk } )
  if subMamiPartner() then
   if ( subFriendship() < 40 ) then
    talk = { 1520 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1540 }
   else
    talk = { 1570, 1580 }
   end
  else
   if ( subFriendship() < 40 ) then
    talk = { 1510 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1530 }
   else
    if ( Rand(2) <= 0 ) then
     talk = { 1550 }
    else
     talk = { 1560 }
    end
   end
  end
  if ( GetUnitInfo( "@MPR_Player_1_0", 11 ) == "HOMURA" and
    talk[1] == 1560 ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 1561 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 1562 } } )
  else
   subCutin( { obj="@MPR_Player_1_0", voice=talk } )
  end
  subDeleteCutin()
 end
end
function PARTNER_REVIVEFRIEND()
 local talk = {}
 if subEQCheck(587) then
  if subMamiPartner() then
   if ( subFriendship() < 40 ) then
    talk = { 1440 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1460 }
   else
    talk = { 1490, 1500 }
   end
  else
   if ( subFriendship() < 40 ) then
    talk = { 1430 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1450 }
   else
    talk = { 1470, 1480 }
   end
  end
  subCutin( { obj="@MPR_Player_1_0", voice=talk } )
  if subMamiPlayer() then
   if ( subFriendship() < 40 ) then
    talk = { 1520 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1540 }
   else
    talk = { 1570, 1580 }
   end
  else
   if ( subFriendship() < 40 ) then
    talk = { 1510 }
   elseif ( subFriendship() < 70 ) then
    talk = { 1530 }
   else
    if ( Rand(2) <= 0 ) then
     talk = { 1550 }
    else
     talk = { 1560 }
    end
   end
  end
  if ( GetUnitInfo( "@MPR_Player_2_0", 11 ) == "HOMURA" and
    talk[1] == 1560 ) then
   subCutin( { obj="@MPR_Player_2_0", voice={ 1561 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 1562 } } )
  else
   subCutin( { obj="@MPR_Player_2_0", voice=talk } )
  end
  subDeleteCutin()
 end
end
function PLAYER_HP_COMMON( unit )
 AddEventTrigger( "PLAYER_HP60", 88, "DURABU", "ANYBODY", unit.UNIT, 60, unit )
 AddEventTrigger( "PLAYER_HP40", 86, "DURABU", "ANYBODY", unit.UNIT, 40, unit )
 AddEventTrigger( "PLAYER_HP20", 85, "DURABU", "ANYBODY", unit.UNIT, 20, unit )
 AddEventTrigger( "PLAYER_HP00", 84, "DURABU", "ANYBODY", unit.UNIT, 00, unit )
end
PLAYER_HP_COMMON( { UNIT = "@MPR_Player_1_0", MATE = "@MPR_Player_2_0" } )
if string.match( GetSystemVar( -94 ), "s101_000" ) then
 AddEventTrigger( "PLAYER_HP00", 84, "DURABU", "ANYBODY", "@MPR_Player_2_0", 00,
      { UNIT = "@MPR_Player_2_0", MATE = "@MPR_Player_1_0" } )
else
 PLAYER_HP_COMMON( { UNIT = "@MPR_Player_2_0", MATE = "@MPR_Player_1_0" } )
end
function PLAYER_HP60()
 local unit = { GetTriggerTable( "UNIT" ), GetTriggerTable( "MATE" ) }
 local talk = {}
 if ( GetUnitInfo( unit[1], 3 ) > 40 and subEQCheck(608) ) then
  subCutin( { obj=unit[1], voice={ 1090, 1100 },
     shake={ 4, 1 } } )
  if ( GetUnitInfo( unit[2], 0 ) > 0 ) then
   if ( ( unit[1] == "@MPR_Player_1_0" and subMamiPlayer() ) or
     ( unit[1] == "@MPR_Player_2_0" and subMamiPartner() ) ) then
     if ( subFriendship() < 40 ) then
      talk = { 1230 }
     elseif ( subFriendship() < 70 ) then
      talk = { 1250 }
     else
      talk = { 1280, 1290 }
     end
   else
     if ( subFriendship() < 40 ) then
      talk = { 1220 }
     elseif ( subFriendship() < 70 ) then
      talk = { 1240 }
     else
      talk = { 1260, 1270 }
     end
   end
   subCutin( { obj=unit[2], voice=talk } )
  end
  subDeleteCutin()
 end
end
function PLAYER_HP40()
 local unit = { GetTriggerTable( "UNIT" ), GetTriggerTable( "MATE" ) }
 local talk = {}
 if ( GetUnitInfo( unit[1], 3 ) > 20 and subEQCheck(606) ) then
  if ( GetUnitInfo( unit[2], 0 ) > 0 and
    subFriendship() >= 40 ) then
   if ( ( unit[1] == "@MPR_Player_1_0" and subMamiPlayer() ) or
     ( unit[1] == "@MPR_Player_2_0" and subMamiPartner() ) ) then
     if ( subFriendship() < 70 ) then
      talk = { 1170 }
     else
      talk = { 1200, 1210 }
     end
   else
     if ( subFriendship() < 70 ) then
      talk = { 1160 }
     else
      talk = { 1180, 1190 }
     end
   end
   subCutin( { obj=unit[2], voice=talk } )
  else
   if ( subMockCheck() or subPrologueCheck() ) then
   else
    subCutin( { obj="KYUBEY", voice={ 1180, 1190 } } )
   end
  end
  subDeleteCutin()
 end
end
function PLAYER_HP20()
 local unit = GetTriggerTable( "UNIT" )
 if ( GetUnitInfo( unit, 0 ) > 0 and subEQCheck(604) ) then
  subCutin( { obj=unit, voice={ 1110, 1120 },
     shake={ 10, 3 } } )
  subDeleteCutin()
 end
end
function PLAYER_HP00()
 local unit = { GetTriggerTable( "UNIT" ), GetTriggerTable( "MATE" ) }
 local unitid = { GetUnitInfo( unit[1], 11 ), GetUnitInfo( unit[2], 11 ) }
 local talk = {}
 if subEQCheck(590) then
  subCutin( { obj=unit[1], voice={ 1130, 1140, 1150 },
     shake={ 12, 3 } } )
  if ( GetUnitInfo( unit[2], 0 ) > 0 ) then
   if ( subFriendship() >= 70 ) then
    if ( unitid[1] == "MADOKA" ) then
     talk = { 1340, 1350, 1380, 1380 }
    elseif ( unitid[1] == "SAYAKA" ) then
     talk = { 1340, 1350, 1390, 1390 }
    elseif ( unitid[1] == "MAMI" ) then
     if ( unitid[2] == "MADOKA" or
       unitid[2] == "SAYAKA" ) then
      talk = { 1360, 1370, 1400, 1400 }
     else
      talk = { 1340, 1350, 1400, 1400 }
     end
    elseif ( unitid[1] == "HOMURA" ) then
     talk = { 1340, 1350, 1410, 1410 }
    elseif ( unitid[1] == "KYOKO" ) then
     talk = { 1340, 1350, 1420, 1420 }
    end
   elseif ( ( unit[1] == "@MPR_Player_1_0" and subMamiPlayer() ) or
      ( unit[1] == "@MPR_Player_2_0" and subMamiPartner() ) ) then
    if ( subFriendship() >= 40 ) then
     talk = { 1330 }
    else
     talk = { 1310 }
    end
   else
    if ( subFriendship() >= 40 ) then
     talk = { 1320 }
    else
     talk = { 1300 }
    end
   end
   subCutin( { obj=unit[2], voice=talk } )
  elseif ( unitid[1] == "HOMURA" ) then
   if ( subMockCheck() or subPrologueCheck() ) then
   else
    subCutin( { obj="KYUBEY", voice={ 1410 } } )
   end
  end
  subDeleteCutin()
 end
 if string.match( GetSystemVar( -94 ), "s101_000" ) then
  AddEventTrigger( "PLAYER_HP60", 88, "DURABU", "ANYBODY", "@MPR_Player_2_0", 60,
       { UNIT = "@MPR_Player_2_0", MATE = "@MPR_Player_1_0" } )
  AddEventTrigger( "PLAYER_HP40", 86, "DURABU", "ANYBODY", "@MPR_Player_2_0", 40,
       { UNIT = "@MPR_Player_2_0", MATE = "@MPR_Player_1_0" } )
  AddEventTrigger( "PLAYER_HP20", 85, "DURABU", "ANYBODY", "@MPR_Player_2_0", 20,
       { UNIT = "@MPR_Player_2_0", MATE = "@MPR_Player_1_0" } )
 end
end
AddEventTrigger( "STATEBAD", 88, "STATEBAD", "@MPR_Player_1_0", { UNIT="@MPR_Player_1_0" } )
AddEventTrigger( "STATEBAD", 88, "STATEBAD", "@MPR_Player_2_0", { UNIT="@MPR_Player_2_0" } )
function STATEBAD()
 if subEQCheck(850) then
  subCutin( { obj=GetTriggerTable("UNIT"), voice={ 1770, 1780 }, shake={ 6, 2 } } )
  subDeleteCutin()
 end
end
function subDonePlayerDurabTrigger( unit )
 if( GetUnitInfo( unit, 3 ) < 60 ) then
  DoneTrigger( "PLAYER_HP60", "UNIT", unit )
 end
 if( GetUnitInfo( unit, 3 ) < 20 ) then
  DoneTrigger( "PLAYER_HP20", "UNIT", unit )
 end
end
subDonePlayerDurabTrigger( "@MPR_Player_1_0" )
subDonePlayerDurabTrigger( "@MPR_Player_2_0" )
AddEventTrigger( "COMBO_10", 99, "COMBO", 10 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 20 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 30 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 40 )
AddEventTrigger( "COMBO_1ST", 99, "COMBO", 50 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 60 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 70 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 80 )
AddEventTrigger( "COMBO_10", 99, "COMBO", 90 )
AddEventTrigger( "COMBO_2ND", 99, "COMBO", 100 )
function COMBO_10()
 CreateArk( "ark_battle_hit_flash" )
end
function COMBO_1ST()
 COMBO_10()
 if subEQCheck(575) then
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
   if subMamiPlayer() then
    subCutin( { obj="@MPR_Player_2_0", voice={ 1810, 1820 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 1790, 1800 } } )
   end
  else
   if ( subMockCheck() or subPrologueCheck() ) then
   else
    subCutin( { obj="KYUBEY", voice={ 1790, 1800 } } )
   end
  end
  subDeleteCutin()
 end
end
function COMBO_2ND()
 COMBO_10()
 if subEQCheck(570) then
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
   if subMamiPlayer() then
    subCutin( { obj="@MPR_Player_2_0", voice={ 1850, 1860 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 1830, 1840 } } )
   end
  else
   if ( subMockCheck() or subPrologueCheck() ) then
   else
    subCutin( { obj="KYUBEY", voice={ 1830, 1840 } } )
   end
  end
  subDeleteCutin()
 end
end
AddEventTrigger( "KNOCKDOWN_PLAYER", 99, "KNOCKDOWN", "@MPR_Player_1_0" )
AddEventTrigger( "KNOCKDOWN_PARTNER", 99, "KNOCKDOWN", "@MPR_Player_2_0" )
function KNOCKDOWN_PLAYER()
 if subEQCheck(750) then
  subCutin( { obj="@MPR_Player_1_0", voice={ 310, 320 }, shake={ 6, 2 } } )
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
    subFriendship() >= 70 ) then
   if subMamiPlayer() then
    subCutin( { obj="@MPR_Player_2_0", voice={ 370, 380 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 350, 360 } } )
   end
  elseif ( subFriendship() >= 40 ) then
   if subMamiPlayer() then
    subCutin( { obj="@MPR_Player_2_0", voice={ 340 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 330 } } )
   end
  else
   if ( subMockCheck() or subPrologueCheck() ) then
   else
    subCutin( { obj="KYUBEY", voice={ 350, 360 } } )
   end
  end
  subCutin( { obj="@MPR_Player_1_0", voice={ 410, 420 }, open=true } )
  subDeleteCutin()
 end
end
function KNOCKDOWN_PARTNER()
 if subEQCheck(755) then
  subCutin( { obj="@MPR_Player_2_0", voice={ 310, 320 }, shake={ 6, 2 } } )
  if ( GetUnitInfo( "@MPR_Player_1_0", 0 ) > 0 and
    subFriendship() >= 70 ) then
   if subMamiPartner() then
    subCutin( { obj="@MPR_Player_1_0", voice={ 340 } } )
   else
    subCutin( { obj="@MPR_Player_1_0", voice={ 330 } } )
   end
  elseif ( subFriendship() >= 40 ) then
   if subMamiPartner() then
    subCutin( { obj="@MPR_Player_1_0", voice={ 370, 380 } } )
   else
    subCutin( { obj="@MPR_Player_1_0", voice={ 350, 360 } } )
   end
  end
  subCutin( { obj="@MPR_Player_2_0", voice={ 410, 420 }, open=true } )
  subDeleteCutin()
 end
end
AddEventTrigger( "PLAYER_ABYSS", 99, "FALL_ABYSS", "@MPR_Player_1_0" )
AddEventTrigger( "PARTNER_ABYSS", 99, "FALL_ABYSS", "@MPR_Player_2_0" )
function PLAYER_ABYSS()
 local puella = GetUnitInfo( "@MPR_Player_1_0", 11 )
 local talk = {}
 if ( puella == "MADOKA" ) then
  talk = { 390, 401 }
 elseif ( puella == "SAYAKA" ) then
  talk = { 391, 401 }
 elseif ( puella == "KYOKO" ) then
  talk = { 391, 400 }
 else
  talk = { 390, 400 }
 end
 SePlay( "SEID_STG_PLAYER_ABYSS" )
 if subEQCheck(595) then
  subCutin( { obj="@MPR_Player_1_0", voice=talk, shake={ 12, 3 } } )
  subDeleteCutin()
 end
end
function PARTNER_ABYSS()
 local puella = GetUnitInfo( "@MPR_Player_2_0", 11 )
 local talk = {}
 if ( puella == "MADOKA" ) then
  talk = { 390, 401 }
 elseif ( puella == "SAYAKA" ) then
  talk = { 391, 401 }
 elseif ( puella == "KYOKO" ) then
  talk = { 391, 400 }
 else
  talk = { 390, 400 }
 end
 SePlay( "SEID_STG_PARTNER_ABYSS" )
 if subEQCheck(596) then
  subCutin( { obj="@MPR_Player_2_0", voice=talk, shake={ 12, 3 } } )
  subDeleteCutin()
 end
end
function TENSION_MAX()
 local talk = {}
 print( "NNNNNNNNNN comagic_enable : " .. GetSystemVar( 4 ) )
 if ( subEQCheck(840) and
   GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
   GetSystemVar( 4 ) >= 1 ) then
  if ( subFriendship() < 40 ) then
   talk = { 1610 }
  elseif ( subFriendship() < 70 ) then
   talk = { 1620 }
  else
   talk = { 1630, 1640 }
  end
  subCutin( { obj="@MPR_Player_2_0", voice=talk } )
  subDeleteCutin()
 end
end
AddEventTrigger( "PARTNER_COVER", 80, "PARTNERCOVER", "@MPR_Player_1_0" )
function PARTNER_COVER()
 if subEQCheck(520) then
  subCutin( { obj="@MPR_Player_1_0", voice={ 520 } } )
  subDeleteCutin()
 end
 if not G_TENSION_MAX then
  AddEventTrigger( "TENSION_MAX", 99, "TENSIONMAX" )
  G_TENSION_MAX = true
 end
end
AddEventTrigger( "WARPZONE_IN", 20, "WARPEXEC" )
function WARPZONE_IN()
 local warptime = 0.35
 Special( "BLOCK_PAUSEMENU", 1 )
 PauseBattle( 1 )
 SePlay( "SEID_STG_WARP_OPEN" )
 FadeOut( warptime, 1, 1 )
 _retry( WaitTime, warptime )
 Special( "FORCEEXEC_GIMMICK_WARP" )
 FadeIn( warptime, 1, 1 )
 _retry( WaitTime, warptime )
 PauseBattle( 0 )
 Special( "BLOCK_PAUSEMENU", 0 )
 UndoTrigger( "WARPZONE_IN" )
end
function WITCH_HP_COMMON( unit )
 AddEventTrigger( "WITCH_HP70", 97, "DURAB", "ANYBODY", unit.ID, 70 )
 AddEventTrigger( "WITCH_HP50", 95, "DURAB", "ANYBODY", unit.ID, 50 )
 AddEventTrigger( "WITCH_HP30", 93, "DURAB", "ANYBODY", unit.ID, 30 )
 AddEventTrigger( "WITCH_HP10", 91, "DURAB", "ANYBODY", unit.ID, 10 )
end
function WITCH_HP70()
 local stage = GetSystemVar( -93 )
 if ( stage == "s104" ) then
  if subEQCheck(556) then
   _retry( EQWait )
   _retry( WaitTime, 1/30 )
   subCutin( { obj="MADOKA2", voice={ 3880 }, face=0 } )
   subCutin( { obj="MADOKA2", voice={ 3890 }, face=0 } )
   subCutin( { obj="MADOKA2", voice={ 3900 }, face=0 } )
   subDeleteCutin()
   _retry( EQWait )
   SetUnitInfo( "@MPR_Enm_MS_W_OCTAVIA1_PRO_0", 1, 31 )
  end
 end
end
function WITCH_HP50()
 local stage = GetSystemVar( -93 )
 if ( stage == "s104" ) then
  if subEQCheck(554) then
   subCutin( { obj="MADOKA2", voice={ 3910 }, face=0 } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3840 } } )
   subDeleteCutin()
   _retry( EQWait )
   SetUnitInfo( "@MPR_Enm_MS_W_OCTAVIA1_PRO_0", 1, 11 )
  end
 else
  if subEQCheck(554) then
   if ( GetUnitInfo( "@MPR_Player_1_0", 0 ) > 0 ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 2430, 2440, 2450 } } )
   end
   if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
     subFriendship() >= 70 ) then
    if subMamiPlayer() then
     subCutin( { obj="@MPR_Player_2_0", voice={ 2480, 2490 } } )
    else
     subCutin( { obj="@MPR_Player_2_0", voice={ 2460, 2470 } } )
    end
   elseif not subPrologueCheck() then
    subCutin( { obj="KYUBEY", voice={ 2460, 2470 } } )
   end
   subDeleteCutin()
  end
 end
end
function WITCH_HP30()
 local stage = GetSystemVar( -93 )
 if ( stage == "s102" ) then
  if subEQCheck(552) then
   _retry( EQWait )
   _retry( WaitTime, 1/30 )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3850 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3860 }, open=true } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3870 }, open=true } )
   subDeleteCutin()
   _retry( EQWait )
   SetUnitInfo( "@MPR_Enm_MS_W_CHARLOTTE1_PRO_0", 1, 1 )
  end
 elseif ( stage == "s104" ) then
  if subEQCheck(552) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3850 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3860 }, open=true } )
   subDeleteCutin()
   _retry( EQWait )
   SetUnitInfo( "@MPR_Enm_MS_W_OCTAVIA1_PRO_0", 1, 1 )
  end
 end
end
function WITCH_HP10()
 local stage = GetSystemVar( -93 )
 if ( stage == "s102" ) then
  SetUnitInfo( "@MPR_Enm_MS_W_CHARLOTTE1_PRO_0", 1, 0 )
 elseif ( stage == "s104" ) then
  if subEQCheck(550) then
   subCutin( { obj="MADOKA2", voice={ 3900 }, face=0 } )
   subDeleteCutin()
   _retry( EQWait )
   SetUnitInfo( "@MPR_Enm_MS_W_OCTAVIA1_PRO_0", 1, 0 )
  end
 end
end
function MIDDLE_COMMON( unit )
 AddEventTrigger( "MIDDLE_KNOCKDOWN", 96, "KNOCKDOWN", unit.ID )
end
function MIDDLE_KNOCKDOWN()
 if subEQCheck(660) then
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
   if subMamiPlayer() then
    subCutin( { obj="@MPR_Player_2_0", voice={ 1670, 1680 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 1650, 1660 } } )
   end
  elseif not subPrologueCheck() then
   subCutin( { obj="KYUBEY", voice={ 1650, 1660 } } )
  end
  subDeleteCutin()
 end
end
function PUELLA_ENEMY_COMMON( unit )
 AddEventTrigger( "PUELLA_ENEMY_HP75", 97, "DURAB", "ANYBODY", unit.ID, 75 )
 AddEventTrigger( "PUELLA_ENEMY_HP50", 95, "DURAB", "ANYBODY", unit.ID, 50, { UNIT=unit.ID } )
 AddEventTrigger( "PUELLA_ENEMY_HP25", 93, "DURAB", "ANYBODY", unit.ID, 25, { UNIT=unit.ID } )
 AddEventTrigger( "PUELLA_ENEMY_KNOCKDOWN", 100, "KNOCKDOWN", unit.ID, { UNIT=unit.ID } )
 AddEventTrigger( "PUELLA_ENEMY_STATEBAD", 105, "STATEBAD", unit.ID, { UNIT=unit.ID } )
end
function PUELLA_ENEMY_HP75()
 local stage = GetSystemVar( -93 )
 if ( stage == "s201" ) then
  if subEQCheck(390) then
   subCutin( { obj="KYOKO", voice={ 3970 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3920 } } )
   subDeleteCutin()
  end
 elseif ( stage == "s203" ) then
  if subEQCheck(390) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 4000 } } )
   subCutin( { obj="MADOKA", voice={ 4011 } } )
   subCutin( { obj="MADOKA", voice={ 4012 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 4010 } } )
   subDeleteCutin()
  end
 elseif ( stage == "s204" ) then
  if subEQCheck(390) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3950 } } )
   subCutin( { obj="HOMURA", voice={ 3870 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3960 } } )
   subCutin( { obj="HOMURA", voice={ 3880 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3970 } } )
   subDeleteCutin()
  end
 elseif ( stage == "s205" ) then
  if subEQCheck(390) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 4020 } } )
   subCutin( { obj="SAYAKA", voice={ 3950 } } )
   subDeleteCutin()
  end
 elseif ( stage == "s206" ) then
  if subEQCheck(390) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3900 } } )
   subCutin( { obj="KYOKO", voice={ 4020 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3910 } } )
   subDeleteCutin()
  end
 end
end
function PUELLA_ENEMY_HP50()
 local stage = GetSystemVar( -93 )
 local p1 = GetUnitInfo( "@MPR_Player_1_0", 11 )
 local puella = string.gsub( string.match( GetUnitInfo( GetTriggerTable( "UNIT" ), 6 ), "_%u+_" ), "_", "" )
 if ( stage == "s205" ) then
  if subEQCheck(380) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 4030 } } )
   subCutin( { obj="SAYAKA", voice={ 3961 } } )
   subCutin( { obj="SAYAKA", voice={ 3962 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 4041 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 4042 } } )
   subDeleteCutin()
  end
 elseif ( stage == "s206" ) then
  if subEQCheck(380) then
   subCutin( { obj="KYOKO", voice={ 4031 } } )
   subCutin( { obj="KYOKO", voice={ 4032 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3920 } } )
   subCutin( { obj="KYOKO", voice={ 4040 }, open=true } )
   subDeleteCutin()
  end
 else
  if subEQCheck(380) then
   subCutin( { obj=puella, voice={ 1090, 1100 }, shake={ 6, 2 } } )
   if ( p1 == "MADOKA" or p1 == "KYOKO" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 2430, 2440, 2450 } } )
   else
    subCutin( { obj="@MPR_Player_1_0", voice={ 2430, 2450 } } )
   end
   if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
     subFriendship() >= 70 ) then
    if subMamiPlayer() then
     subCutin( { obj="@MPR_Player_2_0", voice={ 2480, 2490 } } )
    else
     subCutin( { obj="@MPR_Player_2_0", voice={ 2460, 2470 } } )
    end
   else
   end
   subDeleteCutin()
  end
 end
end
function PUELLA_ENEMY_HP25()
 local puella = string.gsub( string.match( GetUnitInfo( GetTriggerTable( "UNIT" ), 6 ), "_%u+_" ), "_", "" )
 if subEQCheck(370) then
  subCutin( { obj=puella, voice={ 1110, 1120 }, shake={ 10, 3 } } )
  subDeleteCutin()
 end
end
function PUELLA_ENEMY_KNOCKDOWN()
 local puella = string.gsub( string.match( GetUnitInfo( GetTriggerTable( "UNIT" ), 6 ), "_%u+_" ), "_", "" )
 if subEQCheck(410) then
  subCutin( { obj=puella, voice={ 310, 320 }, shake={ 6, 2 } } )
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
   if subMamiPlayer() then
    subCutin( { obj="@MPR_Player_2_0", voice={ 1670, 1680 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 1650, 1660 } } )
   end
  end
  subDeleteCutin()
  _retry( EQWait )
  subCutin( { obj=puella, voice={ 410, 420 } } )
  subDeleteCutin()
 end
end
function PUELLA_ENEMY_STATEBAD()
 local puella = string.gsub( string.match( GetUnitInfo( GetTriggerTable( "UNIT" ), 6 ), "_%u+_" ), "_", "" )
 if subEQCheck(420) then
  subCutin( { obj=puella, voice={ 1770, 1780 }, shake={ 6, 2 } } )
  subDeleteCutin()
 end
end
function PUELLA_START_TALK( puella )
 local ppid = { GetUnitInfo( "@MPR_Player_1_0", 11 ),
       GetUnitInfo( "@MPR_Player_2_0", 11 ) }
 local rnd = Rand(2)
 local talk = { 230, 240 }
 if ( rnd <= 0 ) then
  talk = { 230, 240 }
 else
  talk = { 240, 230 }
 end
 if subEQCheck(400) then
  subCutin( { obj="@MPR_Player_1_0", voice={ talk[1] } } )
  subCutin( { obj=puella, voice={ talk[2] } } )
  if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
   subCutin( { obj="@MPR_Player_2_0", voice={ talk[1] } } )
  end
 end
 subDeleteCutin()
end
function ROOM_IN( floor, text, textpause, floordisp, floorpause )
 local floortime = 1.8
 local firstroom = false
 local stage = GetSystemVar( -93 )
 local p1 = GetUnitInfo( "@MPR_Player_1_0", 11 )
 local p2 = GetUnitInfo( "@MPR_Player_2_0", 11 )
 SetSystemVar( 1, floor )
 if textpause == nil then
  SetSystemVar( -97, text )
 else
  SetSystemVar( -97, textpause )
 end
 if string.match( GetSystemVar( -94 ), "_000_" ) then
  firstroom = true
 end
 if floorpause then
  firstroom = false
 end
 if ( GetSystemVar( 3 ) == 3 ) then
  SetUnitInfo( "@MPR_Player_1_0", 1, 1 )
  if ( GetUnitInfo( "@MPR_Player_2_0", 2 ) > 0 ) then
   SetUnitInfo( "@MPR_Player_2_0", 1, 1 )
  end
 end
 if floordisp ~= false then
  if ( firstroom and subEQCheck(400) ) then
   if ( GetLimitTime() <= 181 and GetLimitTime() > 0 ) then
    if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
     subCutin( { obj="@MPR_Player_2_0", voice={ 180, 190 } } )
    else
     subCutin( { obj="KYUBEY", voice={ 180, 190 } } )
    end
   elseif ( stage == "s090" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3200 } } )
    if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
     subCutin( { obj="@MPR_Player_2_0", voice={ 3200 } } )
    end
   elseif ( stage == "s100" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3820 } } )
   elseif ( stage == "s101" ) then
    subCutin( { obj="@MPR_Player_2_0", voice={ 3820 } } )
    subCutin( { obj="@MPR_Player_1_0", voice={ 3830 } } )
    subCutin( { obj="MEGAHOMU", voice={ 3820 } } )
   elseif ( stage == "s103" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3830 } } )
   elseif ( stage == "s104" ) then
    subCutin( { obj="MADOKA2", voice={ 3840 }, face=3 } )
    subCutin( { obj="@MPR_Player_1_0", voice={ 3820 } } )
   elseif ( stage == "s023" and
      GetUnitInfo( "@MPR_Player_1_0", 11 ) == "KYOKO" and
      GetUnitInfo( "@MPR_Player_2_0", 0 ) <= 0 ) then
    subCutin( { obj="KYUBEY", voice={ 3200 } } )
    subCutin( { obj="@MPR_Player_1_0", voice={ 3880 } } )
    subCutin( { obj="KYUBEY", voice={ 3210 }, open=true } )
   elseif ( stage == "s086" and p1 == "SAYAKA" and p2 == "KYOKO" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3870 } } )
    subCutin( { obj="@MPR_Player_2_0", voice={ 3890 } } )
    subCutin( { obj="@MPR_Player_1_0", voice={ 3880 }, open=true } )
   elseif ( stage == "s086" and p1 == "KYOKO" and p2 == "SAYAKA" ) then
    subCutin( { obj="@MPR_Player_2_0", voice={ 3870 } } )
    subCutin( { obj="@MPR_Player_1_0", voice={ 3890 } } )
    subCutin( { obj="@MPR_Player_2_0", voice={ 3880 }, open=true } )
   elseif ( stage == "s087" and p1 == "KYOKO" and p2 == "SAYAKA" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3930 } } )
    subCutin( { obj="@MPR_Player_2_0", voice={ 3890 } } )
   elseif ( stage == "s077" and p1 == "HOMURA" and p2 == "MADOKA" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3860 } } )
    subCutin( { obj="@MPR_Player_2_0", voice={ 3970 } } )
   elseif ( stage == "s077" and p1 == "MADOKA" and p2 == "HOMURA" ) then
    subCutin( { obj="@MPR_Player_2_0", voice={ 3860 } } )
    subCutin( { obj="@MPR_Player_1_0", voice={ 3970 } } )
   else
    subCutin( { obj="@MPR_Player_1_0", voice={ 70, 80, 90 } } )
    if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
     if subMamiPlayer() then
      if ( subFriendship() >= 70 ) then
       subCutin( { obj="@MPR_Player_2_0", voice={ 160, 170 } } )
      else
       subCutin( { obj="@MPR_Player_2_0", voice={ 120, 130 } } )
      end
     elseif ( subFriendship() >= 70 ) then
      subCutin( { obj="@MPR_Player_2_0", voice={ 140, 150 } } )
     else
      subCutin( { obj="@MPR_Player_2_0", voice={ 100, 110 } } )
     end
    elseif not subPrologueCheck() then
     subCutin( { obj="KYUBEY", voice={ 100, 110 } } )
    end
   end
   _retry( WaitArk )
   subDeleteCutin()
  else
   Special( "BLOCK_PAUSEMENU", 1 )
   subBeforeDemo()
   FadeOut( 0, 0, 1 )
   FadeIn( floortime, 0, 1 )
   _retry( WaitTime, 1/30 )
   PauseBattle( 1 )
  end
  if firstroom then
   CreateArk( "floor" )
   SePlay( "SEID_STG_ROOM_NUMBER" )
   _retry( WaitTime, floortime )
   DeleteArk()
   _retry( WaitArk )
  else
   if BeginDemo( 8 ) then
    CreateArk( "floor" )
    SePlay( "SEID_STG_ROOM_NUMBER" )
    _retry( WaitTime, floortime )
    DeleteArk()
    _retry( WaitArk )
    PauseBattle( 0 )
    subAfterDemo()
    EndDemo()
   end
   FadeIn( 0, 0, 1 )
   Special( "BLOCK_PAUSEMENU", 0 )
   if ( subEQCheck(400) and GetLimitTime() <= 181 and GetLimitTime() > 0 ) then
    if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
     subCutin( { obj="@MPR_Player_2_0", voice={ 180, 190 } } )
    elseif not subPrologueCheck() then
     subCutin( { obj="KYUBEY", voice={ 180, 190 } } )
    end
    subDeleteCutin()
   end
  end
 end
 CreateText( "【 INFORMATION 】," .. text, 6.0 )
 SePlay( "SEID_STG_TEXT_OPEN" )
end
function EVENT_APPEAR_ENEMY_NORMAL()
 local rnd = Rand(3)
 if ( GetSystemVar( 3 ) ~= 3 ) then
  CreateTimedArk( "telop_app_enemy", 5.0, 1 )
  SePlay( "SEID_STG_ENEMY_APPEAR" )
 end
 if subEQCheck(835) then
  if ( rnd <= 0 and GetUnitInfo( "@MPR_Player_1_0", 0 ) > 0 ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 2570, 2580 } } )
  elseif ( rnd <= 1 and GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
    subFriendship() >= 70 ) then
    if subMamiPlayer() then
     subCutin( { obj="@MPR_Player_2_0", voice={ 2610, 2620 } } )
    else
     subCutin( { obj="@MPR_Player_2_0", voice={ 2590, 2600 } } )
    end
  elseif subPrologueCheck() then
   _retry( EQWaitTime, 2.5 )
  else
   subCutin( { obj="KYUBEY", voice={ 2590, 2600 } } )
  end
  subDeleteCutin()
 end
end
function EVENT_APPEAR_ENEMY_SURPRISE()
 local rnd = Rand(3)
 CreateTimedArk( "telop_app_enemy", 5.0, 1 )
 SePlay( "SEID_STG_ENEMY_APPEAR" )
 if subEQCheck(830) then
  if ( rnd <= 0 and GetUnitInfo( "@MPR_Player_1_0", 0 ) > 0 ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 2630, 2640 } } )
  elseif ( rnd <= 1 and GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 and
    subFriendship() >= 70 ) then
    if subMamiPlayer() then
     subCutin( { obj="@MPR_Player_2_0", voice={ 2670, 2680 } } )
    else
     subCutin( { obj="@MPR_Player_2_0", voice={ 2650, 2660 } } )
    end
  elseif subPrologueCheck() then
   _retry( EQWaitTime, 2.5 )
  else
   subCutin( { obj="KYUBEY", voice={ 2650, 2660 } } )
  end
  subDeleteCutin()
 end
end
function EVENT_APPEAR_DOOR( unit, last, state )
 local unitid = GetUnitInfo( unit, 6 )
 local cam = {}
 local hp = { GetUnitInfo( "@MPR_Player_1_0", 0 ),
     GetUnitInfo( "@MPR_Player_2_0", 0 ) }
 if state then
 else
  _retry( EQDelete )
  EndHomuraTimeStop()
  _retry( WaitTime, 1/30 )
 end
 if ( string.find( unitid, "OB_GERT_DOOR_01" ) ~= nil ) then
  cam = { 24.6, 18.1, 83, 102 }
 elseif ( string.find( unitid, "OB_GERT_DOOR_02" ) ~= nil ) then
  cam = { 15, 15, 53, 71 }
 elseif ( string.find( unitid, "OB_CHAR_DOOR_01" ) ~= nil ) then
  cam = { 14.5, 14.5, 50, 80 }
 elseif ( string.find( unitid, "OB_CHAR_DOOR_02" ) ~= nil ) then
  cam = { 11, 11, 43, 69 }
 elseif ( string.find( unitid, "OB_ELLY_DOOR_01" ) ~= nil ) then
  cam = { 12.5, 12.5, 42, 69 }
 elseif ( string.find( unitid, "OB_ELLY_DOOR_02" ) ~= nil ) then
  cam = { 13.5, 13.5, 50, 80 }
 elseif ( string.find( unitid, "OB_ELSA_DOOR_01" ) ~= nil or
    string.find( unitid, "OB_ELSA_DOOR_03" ) ~= nil ) then
  cam = { 15, 18.9, 50, 80 }
 elseif ( string.find( unitid, "OB_ELSA_DOOR_02" ) ~= nil or
    string.find( unitid, "OB_ELSA_DOOR_04" ) ~= nil ) then
  cam = { 18.5, 29.1, 80, 130 }
 elseif ( string.find( unitid, "OB_OKTA_DOOR_01" ) ~= nil ) then
  cam = { 17.3, 17.3, 58, 84 }
 elseif ( string.find( unitid, "OB_OKTA_DOOR_02" ) ~= nil ) then
  cam = { 12, 12, 50, 70 }
 elseif ( string.find( unitid, "OB_IZAB_DOOR_01" ) ~= nil ) then
  cam = { 15, 15, 44, 75 }
 elseif ( string.find( unitid, "OB_IZAB_DOOR_02" ) ~= nil ) then
  cam = { 22.1, 14.6, 71, 114 }
 elseif ( string.find( unitid, "OB_PATR_DOOR_01" ) ~= nil ) then
  cam = { 15, 38.6, 76, 160 }
 elseif ( string.find( unitid, "OB_WALP_DOOR_01" ) ~= nil ) then
  cam = { 25.6, 11.8, 88, 130 }
    else
     return
    end
 local rotate = { 1, 1 }
 for i = 1, table.maxn( rotate ) do
  if ( Rand(2) == 0 ) then rotate[i] = -1 end
 end
 if ( GetSystemVar( 3 ) ~= 3 ) then
  if BeginDemo() then
   subBeforeDemo()
   CamFar( 20000 )
   CreateUnit( unit )
   Path( 3, 6, 45, 40, 0, 10 )
   Path( 2, 5, 0, 0, 0, 10 )
   Path( 0, 1, "PARENT_Y", unit,
      0, cam[1], 0,
      0, cam[1] + 0, 0,
      0, 10 )
   Path( 1, 2, "PARENT_Y", unit,
      0, cam[2], 0,
      0, 0, cam[3] + Rand( cam[4] - cam[3] ),
      0, -20 + Rand(40), 0,
      0, rotate[1] * 1, 0,
      0, rotate[2] * ( 1 + Rand(20) * 0.1 ), 0 )
   TALK_APPEAR_DOOR( unit, last, hp )
   SeStop( -1 )
   _retry( WaitTime, 1/30 )
   SePlay( "SEID_STG_JINGLE_DOOR" )
   SePlay( "SEID_STG_DOOR_APPEAR" )
   _retry( WaitElapsedTime, 4 )
   _retry( EQWait )
   subAfterDemo()
   EndDemo()
  end
  CreateUnit( unit, 1 )
 else
 end
end
function TALK_APPEAR_DOOR( unit, last, hp )
 local talk = {}
 if subEQCheck(505) then
  if last then
   if ( hp[2] > 0 ) then
    if ( subFriendship() >= 70 ) then
     if subMamiPlayer() then
      talk = { 1970, 1980 }
     else
      talk = { 1950, 1960 }
     end
     subCutin( { obj="@MPR_Player_2_0", voice=talk } )
    end
    if ( subFriendship() < 70 ) then
     if subMamiPartner() then
      talk = { 2010, 2020 }
     else
      talk = { 1990, 2000 }
     end
    else
     if subMamiPartner() then
      talk = { 2050, 2060 }
     else
      talk = { 2030, 2040 }
     end
    end
    subCutin( { obj="@MPR_Player_1_0", voice=talk } )
   elseif not subPrologueCheck() then
    subCutin( { obj="KYUBEY", voice={ 1950, 1960 } } )
   end
  else
   if ( subFriendship() >= 70 and hp[2] > 0 ) then
    if subMamiPlayer() then
     if ( not subDoorCheck( unit ) and
       GetUnitInfo( "@MPR_Player_2_0", 11 ) == "MADOKA" ) then
      talk = { 1930 }
     else
      talk = { 1930, 1940 }
     end
    else
     if ( not subDoorCheck( unit ) and
       ( GetUnitInfo( "@MPR_Player_2_0", 11 ) == "MADOKA" or
         GetUnitInfo( "@MPR_Player_2_0", 11 ) == "KYOKO" ) ) then
      talk = { 1910 }
     else
      talk = { 1910, 1920 }
     end
    end
    subCutin( { obj="@MPR_Player_2_0", voice=talk } )
   else
    if subDoorCheck( unit ) then
     subCutin( { obj="KYUBEY", voice={ 1910, 1920 } } )
    else
     subCutin( { obj="KYUBEY", voice={ 1920 } } )
    end
   end
  end
  subDeleteCutin()
 end
end
AddEventTrigger( "ROOM_EXIT", 10, "ROOMEXIT" )
function ROOM_EXIT()
 local fadetime = 1.5
 local door = GetUnitInfo( GetSystemVar( -92 ), 6 )
 local stairs = { "ELLY_DOOR_02", "ELSA_DOOR_01", "ELSA_DOOR_02", "ELSA_DOOR_03",
      "ELSA_DOOR_04", "OKTA_DOOR_02", "PATR_DOOR_01" }
 local stairs_check = false
 for i = 1, table.maxn( stairs ) do
  if string.match( door, stairs[i] ) then
   stairs_check = true
   break
  end
 end
 Special( "BLOCK_PAUSEMENU", 1 )
 SetSystemVar( 25, GetLimitTime() )
 print( "GetLimitTime=" .. GetLimitTime() )
 print( "SYS_LIMIT_TIME=" .. GetSystemVar( 25 ) )
 SetSystemVar( 76, 1 )
 if ( BeginDemo( 8 ) ) then
  subBeforeDemo()
  PauseBattle( 1 )
  FadeOut( fadetime, 0, 1 )
  if stairs_check then
   SePlay( "SEID_STG_ROOMNEXT" )
   print( "NNNNNNNNNN: STAIRS" )
  else
   SePlay( "SEID_STG_ROOMNEXT_DOOR" )
   print( "NNNNNNNNNN: DOOR" )
  end
  _retry( WaitTime, fadetime )
  FadeOut( 0, 0, 1 )
   Special( "MUSIC_CONTINUE" )
  PauseBattle( 0 )
  EndDemo()
 end
 if string.match( GetSystemVar( -93), "s5" ) then
 else
  Special( "BLOCK_PAUSEMENU", 0 )
 end
end
function DEMO_VANISH_DOOR( unit )
 local unitid = GetUnitInfo( unit, 6 )
 local cam = {}
 PauseBattle( 1 )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 PauseBattle( 0 )
 if ( string.find( unitid, "OB_GERT_DOOR_01" ) ~= nil ) then
  cam = { 24.6, 18.1, 83, 102 }
 elseif ( string.find( unitid, "OB_GERT_DOOR_02" ) ~= nil ) then
  cam = { 15, 15, 53, 71 }
 elseif ( string.find( unitid, "OB_CHAR_DOOR_01" ) ~= nil ) then
  cam = { 14.5, 14.5, 50, 80 }
 elseif ( string.find( unitid, "OB_CHAR_DOOR_02" ) ~= nil ) then
  cam = { 11, 11, 43, 69 }
 elseif ( string.find( unitid, "OB_ELLY_DOOR_01" ) ~= nil ) then
  cam = { 12.5, 12.5, 42, 69 }
 elseif ( string.find( unitid, "OB_ELLY_DOOR_02" ) ~= nil ) then
  cam = { 13.5, 13.5, 50, 80 }
 elseif ( string.find( unitid, "OB_ELSA_DOOR_01" ) ~= nil or
    string.find( unitid, "OB_ELSA_DOOR_03" ) ~= nil ) then
  cam = { 15, 18.9, 50, 80 }
 elseif ( string.find( unitid, "OB_ELSA_DOOR_02" ) ~= nil or
    string.find( unitid, "OB_ELSA_DOOR_04" ) ~= nil ) then
  cam = { 18.5, 29.1, 80, 130 }
 elseif ( string.find( unitid, "OB_OKTA_DOOR_01" ) ~= nil ) then
  cam = { 17.3, 17.3, 58, 84 }
 elseif ( string.find( unitid, "OB_OKTA_DOOR_02" ) ~= nil ) then
  cam = { 12, 12, 50, 70 }
 elseif ( string.find( unitid, "OB_IZAB_DOOR_01" ) ~= nil ) then
  cam = { 15, 15, 44, 75 }
 elseif ( string.find( unitid, "OB_IZAB_DOOR_02" ) ~= nil ) then
  cam = { 22.1, 14.6, 71, 114 }
 elseif ( string.find( unitid, "OB_PATR_DOOR_01" ) ~= nil ) then
  cam = { 15, 38.6, 76, 160 }
 elseif ( string.find( unitid, "OB_WALP_DOOR_01" ) ~= nil ) then
  cam = { 25.6, 11.8, 88, 130 }
    else
     return
    end
 if ( BeginDemo() ) then
  subBeforeDemo()
  CamFar( 20000 )
  CreateUnit( unit, 1 )
  if ( string.match( GetUnitInfo( "@MPR_Player_1_0", 11 ), "KYOKO" ) ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 1320 } } )
  else
   subCutin( { obj="@MPR_Player_1_0", voice={ 2070 } } )
  end
  subDeleteCutin()
  local rot_y = 1
  if ( Rand(2) <= 0 ) then rot_y = rot_y * -1 end
  Path( 3, 6, 45, 40, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 1, "PARENT_Y", unit,
     0, cam[1], 0,
     0, cam[1] + 0, 0,
     0, 10 )
  Path( 1, 2, "PARENT_Y", unit,
     0, cam[2], 0,
     0, 0, cam[3] + Rand( cam[4] - cam[3] ),
     0, -20 + Rand(40), 0,
     rot_y, -1, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_JINGLE_MINUS" )
  KillUnit( unit, 0 )
  SePlay( "SEID_STG_DOOR_VANISH" )
  _retry( WaitElapsedTime, 4 )
  _retry( EQWait )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_APPEAR_BARRIER( unit, center, obj_etc, state )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  for i = 1, table.maxn( unit ) do
   CreateUnit( unit[i] )
  end
  if obj_etc then
   for i = 1, table.maxn( obj_etc ) do
    CreateUnit( obj_etc[i], 1, 1 )
   end
  end
  local rnd = Rand(30)
  local dis = 100 + rnd
  local hei = 38 + 14*(rnd/40)
  local hei_up = 3
  if ( state == "izab_area01" ) then
   rnd = rnd * 0.5
   dis = dis * 0.8
   hei = hei * 0.6
   hei_up = hei_up * 0.65
  end
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", center, 0, hei, 0 )
  Path( 1, 2, "PARENT_Y", center,
     0, hei - 4 * ( 1 + rnd/40 ), 0,
     0, 0, dis,
     0, -14 + Rand(29), 0,
     0, hei_up, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_BARRIER_APPEAR" )
  SePlay( "SEID_STG_JINGLE_MINUS" )
  _retry( WaitTime, 3 )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_VANISH_BARRIER( unit, center, obj_etc, state, dis )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  for i = 1, table.maxn( unit ) do
   CreateUnit( unit[i], 1, 1 )
  end
  if obj_etc then
   for i = 1, table.maxn( obj_etc ) do
    CreateUnit( obj_etc[i], 1, 1 )
   end
  end
  local rnd = Rand(30)
  local hei = 38 + 14*(rnd/40)
  local hei_down = -3
  if dis then
  else
   dis = 100 + rnd
  end
  if ( state == "izab_area01" ) then
   rnd = rnd * 0.5
   dis = dis * 0.8
   hei = hei * 0.6
   hei_down = hei_down * 0.65
  end
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", center, 0, hei, 0 )
  Path( 1, 2, "PARENT_Y", center,
     0, hei - 4 * ( 1 + rnd/40 ), 0,
     0, 0, dis,
     0, -14 + Rand(29), 0,
     0, hei_down, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_BARRIER_VANISH" )
  SePlay( "SEID_STG_JINGLE_PLUS" )
  for i = 1, table.maxn( unit ) do
   KillUnit( unit[i], 0 )
  end
  subCutin( { obj="@MPR_Player_1_0", voice={ 2080, 2090 } } )
  subDeleteCutin()
  _retry( WaitTime, 3 )
  _retry( EQWait )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_APPEAR_SCAFFOLDING( unit, center, fix )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  for i = 1, table.maxn( unit ) do
   CreateUnit( unit[i] )
  end
  if fix ~= nil then
   for i = 1, table.maxn( fix ) do
    CreateUnit( fix[i] )
    Path( 4, fix[i], 0, 0, "PARENT_FIRST", fix[i], 0, 0, 0 )
   end
  end
  local rnd = Rand(58)
  local dis = 124 + rnd
  local height = 66 + 26 * ( 1 - rnd/58 )
  local r_y = 20 + Rand(15)
  if ( Rand(2) <= 0 ) then r_y = r_y * -1 end
  local roll = 2
  if ( Rand(2) <= 0 ) then roll = roll * -1 end
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", center, 0, 13, 0 )
  Path( 1, 2, "PARENT_Y", center,
     0, height, 0,
     0, 0, dis,
     0, r_y, 0,
     0, 0, 0,
     0, roll, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_SCAFFOLDING_APPEAR" )
  SePlay( "SEID_STG_JINGLE_PLUS" )
  _retry( WaitTime, 2.5 )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_VANISH_SCAFFOLDING( unit, center, fix )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  for i = 1, table.maxn( unit ) do
   CreateUnit( unit[i], 1 )
  end
  if fix ~= nil then
   for i = 1, table.maxn( fix ) do
    CreateUnit( fix[i], 1 )
    Path( 4, fix[i], 0, 0, "PARENT_FIRST", fix[i], 0, 0, 0 )
   end
  end
  local rnd = Rand(58)
  local dis = 124 + rnd
  local height = 66 + 26 * ( 1 - rnd/58 )
  local r_y = 20 + Rand(15)
  if ( Rand(2) <= 0 ) then r_y = r_y * -1 end
  local roll = 2
  if ( Rand(2) <= 0 ) then roll = roll * -1 end
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", center, 0, 13, 0 )
  Path( 1, 2, "PARENT_Y", center,
     0, height, 0,
     0, 0, dis,
     0, r_y, 0,
     0, roll, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_JINGLE_MINUS" )
  for i = 1, table.maxn( unit ) do
   KillUnit( unit[i], 0 )
  end
  SePlay( "SEID_STG_SCAFFOLDING_VANISH" )
  if fix ~= nil then
   for i = 1, table.maxn( fix ) do
    KillUnit( fix[i], 0 )
   end
  end
  _retry( WaitTime, 2.5 )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_APPEAR_KEYITEM( unit, rot_y, no_talk )
 if rot_y then
 else
  rot_y = 0
 end
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  CreateUnit( unit )
  local rnd = Rand(28)
  local dis = 42 + rnd
  local hei = 11 + 4*(rnd/28)
  Path( 3, 6, 45, 30, 0, 30 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, 9.4, 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, hei, 0,
     0, 0, dis,
     0, -30 + Rand(60) + rot_y, 0,
     0, 0, 0,
     0, 0, 0 )
  if no_talk then
  else
   subCutin( { obj="@MPR_Player_1_0", voice={ 1870, 1880 } } )
   subDeleteCutin()
  end
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_JINGLE_PLUS" )
  SePlay( "SEID_STG_APPEAR_DROPITEM" )
  Path( 0, 0,
     GetWorldInfo( 3 ),
     GetWorldInfo( 4 ),
     GetWorldInfo( 5 ) )
  Path( 1, 0,
     GetWorldInfo( 0 ),
     GetWorldInfo( 1 ),
     GetWorldInfo( 2 ) )
  _retry( WaitElapsedTime, 3 )
  _retry( EQWait )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_VANISH_KEYITEM( unit )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  CreateUnit( unit, 1 )
  local rnd = Rand(28)
  local dis = 42 + rnd
  local hei = 11 + 4*(rnd/28)
  Path( 3, 6, 45, 60, 0, 30 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, 9.4, 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, hei, 0,
     0, 0, dis,
     0, -30 + Rand(60), 0,
     0, 0, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  Path( 0, 0,
     GetWorldInfo( 3 ),
     GetWorldInfo( 4 ),
     GetWorldInfo( 5 ) )
  Path( 1, 0,
     GetWorldInfo( 0 ),
     GetWorldInfo( 1 ),
     GetWorldInfo( 2 ) )
  SePlay( "SEID_STG_JINGLE_MINUS" )
  _retry( WaitTime, 0.5 )
  KillUnit( unit, 0 )
  _retry( WaitElapsedTime, 2.5 )
  _retry( EQWait )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_APPEAR_SWITCH( unit, obj_etc, state )
 if ( state == "CONTINUE" ) then
 else
  _retry( EQDelete )
  EndHomuraTimeStop()
  _retry( WaitTime, 1/30 )
 end
 if ( BeginDemo() ) then
  subBeforeDemo()
  CreateUnit( unit )
  if obj_etc then
   for i = 1, table.maxn( obj_etc ) do
    CreateUnit( obj_etc[i], 1, 1 )
   end
  end
  local dis = 28 + Rand( 15 )
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, 8.7, 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, 13.8, 0,
     0, 0, dis,
     0, -40 + Rand(80), 0,
     0, -1, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_SWITCH_APPEAR" )
  SePlay( "SEID_STG_JINGLE_SWITCH" )
  _retry( WaitTime, 3 )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_VANISH_SWITCH( unit, obj_etc )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  CreateUnit( unit, 1 )
  if obj_etc then
   for i = 1, table.maxn( obj_etc ) do
    CreateUnit( obj_etc[i], 1, 1 )
   end
  end
  local dis = 28 + Rand( 15 )
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, 8.7, 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, 13.8, 0,
     0, 0, dis,
     0, -40 + Rand(80), 0,
     0, 1, 0,
     0, 0, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_SWITCH_VANISH" )
  SePlay( "SEID_STG_JINGLE_MINUS" )
  KillUnit( unit, 0 )
  _retry( WaitTime, 3 )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_WARP_ON( unit, sysvar, state, obj_etc )
 if ( state == "CONTINUE" ) then
 else
  _retry( EQDelete )
  EndHomuraTimeStop()
  _retry( WaitTime, 1/30 )
 end
 if ( BeginDemo() ) then
  subBeforeDemo()
  SetSystemVar( sysvar, 0 )
  CreateUnit( unit, 1 )
  if obj_etc then
   for i = 1, table.maxn( obj_etc ) do
    CreateUnit( obj_etc[i], 1, 1 )
   end
  end
  local roll = 2
  if ( Rand(2) <= 0 ) then roll = roll * -1 end
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, 15.6, 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, 35.6, 0,
     0, 0, 62 + Rand(40),
     0, -20 + Rand(40), 0,
     0, 0, 0,
     0, roll, 0 )
  SetSystemVar( sysvar, 1 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_WARP_OPEN" )
  SePlay( "SEID_STG_JINGLE_PLUS" )
  _retry( WaitTime, 2.5 )
  subAfterDemo()
  EndDemo()
 end
end
function DEMO_WARP_OFF( unit, sysvar )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  SetSystemVar( sysvar, 1 )
  CreateUnit( unit, 1 )
  local roll = 2
  if ( Rand(2) <= 0 ) then roll = roll * -1 end
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, 15.6, 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, 35.6, 0,
     0, 0, 62 + Rand(40),
     0, -45 + Rand(90), 0,
     0, 0, 0,
     0, roll, 0 )
  SetSystemVar( sysvar, 0 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_WARP_OPEN" )
  SePlay( "SEID_STG_JINGLE_PLUS" )
  _retry( WaitTime, 2.5 )
  subAfterDemo()
  EndDemo()
 end
end
function EVENT_FINISH( unit )
 local center = GetUnitInfo( unit, 6 )
 local cam = {}
 local puella = GetUnitInfo( unit, 6 )
 local rot_z = 0
 if ( string.match( unit, "@MPR_Player_1_0" ) ) then
  puella = string.gsub( puella, "MS_", "" )
 else
  puella = string.gsub( string.match( GetUnitInfo( unit, 6 ), "_%u+_" ), "_", "" )
 end
 print( "NNNNNNNNNN puella : " .. puella )
 SetSystemVar( 41, 0 )
 SetSystemVar( 42, 0 )
 SetSystemVar( 43, 0 )
 SetSystemVar( 44, 0 )
 SetSystemVar( 45, 0 )
 Special( "BLOCK_PAUSEMENU", 1 )
 Special( "INVALIDATE_GIMMICK", 1 )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 MessageUnit( unit, "CMN_VANISH_NOT_DELETE" )
 if ( BeginDemo( 1 +
     8 +
     16 +
     128 ) ) then
  subBeforeDemo()
  PauseBattle( 1 )
  CreateArk( "ark_mission_finish" )
  ScreenNegapogi( 1, 0 )
  Music( -1 )
  if string.match( center, "ANTHONY" ) then
   cam = { 7.7 * 2, 19.9 * 2 }
  elseif string.match( center, "SMALLADELBERT" ) then
   cam = { 8.1 * 2, 21.9 * 2 }
  elseif string.match( center, "BIGADELBERT" ) then
   cam = { 11.4 * 2, 26.9 * 2 }
  elseif string.match( center, "PYOTR" ) then
   cam = { 4.4 * 2, 27.1 * 2 }
  elseif string.match( center, "NURSE" ) then
   cam = { 13 * 1.5, 33.1 * 1.5 }
  elseif ( string.match( center, "DANIYYEL" ) or
     string.match( center, "JENNIFE" ) ) then
   cam = { 8.9 * 2, 25.3 * 2 }
  elseif string.match( center, "TVHEAD" ) then
   cam = { 8.9 * 1.5, 22.2 * 1.5 }
  elseif string.match( center, "SEBASTIANSA" ) then
   cam = { 12 * 2, 37.9 * 2 }
  elseif string.match( center, "SEBASTIANSB" ) then
   cam = { 8.6 * 2, 37.7 * 2 }
  elseif string.match( center, "HOLGER" ) then
   cam = { 7 * 2, 30 * 2 }
  elseif string.match( center, "CLARISSA" ) then
   cam = { 10.7 * 2, 34.2 * 2 }
  elseif string.match( center, "WHEEL" ) then
   cam = { 15.6 * 2, 54.5 * 2 }
   rot_z = 90
  elseif string.match( center, "MICHAELAA" ) then
   cam = { 11.5 * 1.5, 36.8 * 1.5 }
  elseif string.match( center, "MICHAELAB" ) then
   cam = { 8 * 3, 24.9 * 3 }
  elseif string.match( center, "MATHIEUB" ) then
   cam = { 11.3 * 2, 26.9 * 2 }
  elseif string.match( center, "MATHIEU" ) then
   cam = { 6 * 2, 26.6 * 2 }
  else
   cam = { 10, 25 }
  end
  local roll = Rand(10) + 11
  if ( Rand(2) <= 0 ) then roll = roll * -1 end
  local roll_y = 60 - Rand(120)
  Path( 3, 6, 45, 60, 0, 10 )
  Path( 2, 5, roll, roll, 0, 5 )
  Path( 0, 0, "PARENT_Y", unit, 0, cam[1], 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, cam[1], 0,
     0, 0, cam[2] * 0.8,
     0, roll_y + rot_z, 0,
     0, 0, 0,
     0, 0, 0 )
  if ( ( puella == "MADOKA" or puella == "SAYAKA" or puella == "MAMI" or
      puella == "HOMURA" or puella == "KYOKO" ) and
    not string.match( unit, "@MPR_Player_1_0" ) ) then
   subCutin( { obj=puella, voice={ 1130, 1140, 1150 } } )
  end
  subCutin( { obj="@MPR_Player_1_0", voice={ 2270, 2280, 2290 } } )
  DeleteArk()
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_FINISH_ARK" )
  SePlay( "SEID_STG_FINISH_ATTACK" )
  _retry( WaitArk )
  _retry( EQWait )
  _retry( WaitTime, 0.1 )
  ScreenNegapogi( 0, 0 )
  subAfterDemo()
  PauseBattle( 0 )
  EndDemo()
 end
 subBeforeDemo()
 KillUnit( "ENEMY_ALL", 0 )
 BeginDemo( 8 )
 if ( subFriendship() < 40 ) then
  if ( subMockCheck() or subPrologueCheck() ) then
  else
   subCutin( { obj="KYUBEY", voice={ 2320, 2330 } } )
  end
 else
  if subMamiPlayer() then
   if ( subFriendship() < 70 ) then
    subCutin( { obj="@MPR_Player_2_0", voice={ 2310 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 2340, 2350 } } )
   end
  else
   if ( subFriendship() < 70 ) then
    subCutin( { obj="@MPR_Player_2_0", voice={ 2300 } } )
   else
    subCutin( { obj="@MPR_Player_2_0", voice={ 2320, 2330 } } )
   end
  end
 end
 subDeleteCutin()
 if string.match( GetSystemVar( -93 ), "s10" ) then
  if CheckBusy() then
   _retry( EQWait )
   _retry( WaitTime, 0.5 )
  else
   _retry( WaitTime, 1 )
  end
  EndDemo()
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  Special( "BLOCK_PAUSEMENU", 0 )
  EVENT_STAGE_CLEAR_PROLOGUE()
 else
  if CheckBusy() then
   _retry( EQWait )
   _retry( WaitTime, 0.5 )
  else
   _retry( WaitTime, 2.5 )
  end
  EndDemo()
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  Special( "BLOCK_PAUSEMENU", 0 )
  EVENT_STAGE_CLEAR( "middle" )
 end
end
function EVENT_FINISH_BOSS( unit, clear, nextphase )
 local witches = { "GERTRUD", "CHARLOTTE1", "CHARLOTTE2", "ELLY", "ELZAMARIA",
       "ISABELLE", "PATRICIA", "OCTAVIA1", "WALPURGIS", "OCTAVIA2" }
 local witches_se = 0
 for i = 1, table.maxn( witches ) do
  if ( string.match( GetUnitInfo( unit, 6 ), witches[i] ) ) then
   witches_se = 10010 + 20 * ( i - 1 )
   break
  end
 end
 if ( witches_se <= 0 ) then
  witches_se = 10090
 end
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 Special( "INVALIDATE_GIMMICK", 1 )
 if ( BeginDemo( 8 +
     128 ) ) then
  PauseBattle( 1 )
  BattleGauge( 0 )
  Music( -1 )
  FadeOut( 2, 1, 1 )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_FINISH_ATTACK" )
  _retry( WaitTime, 2 )
  PauseBattle( 0 )
  EndDemo()
 end
 DeleteUnit( unit, 1 )
 local demo_mdl = false
 if ( string.match( unit, "OCTAVIA" ) or
   string.match( unit, "WALPURGIS" ) ) then
  demo_mdl = true
 end
 unit = string.gsub( unit, "2nd", "", 1 )
 if string.match( unit, "W_CHARLOTTE2" ) then
  unit = "@MPR_Enm_MS_W_CHARLOTTE2_DEAD_0"
 end
 local camera = "@EVOB_" .. string.gsub( GetUnitInfo( unit, 6 ), "MS_W_", "", 1 ) .. "_DEAD:0"
 camera = string.gsub( camera, "_HYPER", "", 1 )
 camera = string.gsub( camera, "_PRO", "", 1 )
 camera = string.gsub( camera, "_2nd", "", 1 )
  camera = string.gsub( camera, "_SUB", "", 1 )
  camera = string.gsub( camera, "_BAD", "", 1 )
 if ( BeginDemo() ) then
  if ( GetSystemVar( -93 ) ~= "s104" ) then
   subBeforeDemo()
   CamFar( 20000 )
   _retry( EQVoice, "MADOKAV", { witches_se } )
   if demo_mdl then
   else
    CreateUnit( unit, 1, 1 )
   end
   CreateUnit( camera, 1, 1 )
   if string.match( unit, "ELZAMARIA" ) then
    Locate( unit, 0, 98, -530, 0, 0 )
    Locate( camera, 0, 14, 0, 0, 0 )
   elseif demo_mdl then
    Locate( camera, 0, 0, 0, 0, 0 )
   else
    Locate( unit, 0, 0, 0, 0, 0 )
    Locate( camera, 0, 0, 0, 0, 0 )
   end
   CamAttach( camera, 0, "camera1" )
   if demo_mdl then
   else
    SetMotion( unit, 0, 11010, 0, 0 )
   end
   SetMotion( camera, 0, 1, 0, 0 )
   FadeIn( 2, 1, 1 )
   _retry( WaitTime, 2 )
   _retry( WaitMotion, camera )
   if string.match( GetSystemVar( -93 ), "s10" ) then
    FadeIn( 0, 0, 1 )
    _retry( WaitTime, 0.5 )
    FadeOut( 1, 0, 1 )
   else
    FadeOut( 1, 1, 1 )
   end
   _retry( WaitTime, 1 )
   if demo_mdl then
   else
    SetMotion( unit, 1, 11010, 0 )
   end
   SetMotion( camera, 1, 1, 0 )
   CamAttach( camera, 1 )
   if nextphase then
    SetSystemVar( 25, GetLimitTime() )
    Special( "MISSION_JUMP_PHASE", nextphase )
   else
    subAfterDemo()
   end
   EndDemo()
  end
  if ( string.match( GetSystemVar( -93 ), "s10" ) or
    ( string.match( GetSystemVar( -93 ), "s090" ) and
      GetSystemVar( 3 ) == 0 ) ) then
   Special( "MISSION_CLEAR" )
  end
 end
 if ( string.match( GetSystemVar( -93 ), "s10" ) or
   ( string.match( GetSystemVar( -93 ), "s090" ) and
     GetSystemVar( 3 ) == 0 ) ) then
  if ( GetSystemVar( -93 ) == "s104" ) then
   _retry( WaitTime, 0.5 )
  end
 else
  DeleteUnit( "ENEMY_ALL", 0 )
  BattleGauge( 0 )
  PauseLimitTime( 1 )
  if nextphase then
  else
   FadeIn( 0.5, 1, 1 )
  end
  if clear == nil or clear == true then
   EVENT_STAGE_CLEAR( "boss" )
  end
 end
 Special( "MUSIC_CONTINUE" )
end
function EVENT_STAGE_CLEAR( stage_flag )
 local stage = GetSystemVar( -93 )
 local p1 = GetUnitInfo( "@MPR_Player_1_0", 11 )
 local p2 = GetUnitInfo( "@MPR_Player_2_0", 11 )
 local talk = {}
 local rnd = 0
 KillUnit( "ENEMY_ALL", 0, 1 )
 Special( "INVALIDATE_GIMMICK", 1 )
 Special( "BLOCK_PAUSEMENU", 1 )
 if ( stage_flag ~= "middle" and stage_flag ~= "boss" ) then
  Music( -3 )
  _retry( WaitTime, 2.5 )
 end
 _retry( EQDelete )
 _retry( WaitTime, 1/30 )
 if ( BeginDemo( 8 +
     16 ) ) then
  PauseLimitTime( 1 )
  Special( "UNBREAKABLE" )
  BattleGauge( 0 )
  DeleteArk()
  DeleteTimedArk()
  Music( "BGM_STAGE_CLEAR" )
  CreateArk( "ark_mission_stage_clear" )
  _retry( EQWaitTime, 0.5 )
  if ( stage == "s012" and p1 == "MADOKA" and p2 == "KYOKO" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3920 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3870 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3930 }, open=true } )
  elseif ( stage == "s084" and p1 == "MADOKA" and p2 == "SAYAKA" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3940 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3850 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3950 }, open=true } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3860 }, open=true } )
  elseif ( stage == "s076" and p1 == "HOMURA" and p2 == "MAMI" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3830 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3880 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3840 }, open=true } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3890 }, open=true } )
  elseif ( stage == "s024" and p1 == "MAMI" and p2 == "HOMURA" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3900 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3850 } } )
  elseif ( stage == "s024" and p1 == "HOMURA" and p2 == "MAMI" ) then
   subCutin( { obj="@MPR_Player_2_0", voice={ 3900 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3850 } } )
  elseif ( stage == "s077" and p1 == "MADOKA" and p2 == "MAMI" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3980 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3930 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3990 }, open=true } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3940 }, open=true } )
  elseif ( stage == "s077" and p1 == "MAMI" and p2 == "MADOKA" ) then
   subCutin( { obj="@MPR_Player_2_0", voice={ 3980 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3930 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3990 }, open=true } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3940 }, open=true } )
  elseif ( stage == "s201" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3930 } } )
   subCutin( { obj="KYOKO", voice={ 3980 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3940 }, open=true } )
  elseif ( stage == "s203" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 2780, 2790 } } )
  elseif ( stage == "s204" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3980 } } )
   subCutin( { obj="HOMURA", voice={ 3890 } } )
  else
   if ( stage_flag == "boss" ) then
    rnd = Rand(3)
    if ( rnd == 0 ) then
     talk = { 2500 }
    else
     talk = { 2510, 2520 }
    end
    if ( talk[1] == 2500 and GetUnitInfo( "@MPR_Player_1_0", 11 ) == "SAYAKA" ) then
     subCutin( { obj="@MPR_Player_1_0", voice={ 2501 } } )
     subCutin( { obj="@MPR_Player_1_0", voice={ 2502 } } )
    else
     subCutin( { obj="@MPR_Player_1_0", voice=talk } )
    end
    if ( subFriendship() >= 70 ) then
     if subMamiPlayer() then
      subCutin( { obj="@MPR_Player_2_0", voice={ 2550, 2560 } } )
     else
      subCutin( { obj="@MPR_Player_2_0", voice={ 2530, 2540 } } )
     end
    else
     subCutin( { obj="KYUBEY", voice={ 2530, 2540 } } )
    end
   else
    if subMockCheck() then
     if ( p1 == "MADOKA" ) then
      subCutin( { obj="@MPR_Player_1_0", voice={ 2770, 2780 } } )
     elseif ( p1 == "SAYAKA" or p1 == "MAMI" or p1 == "HOMURA" ) then
      subCutin( { obj="@MPR_Player_1_0", voice={ 2770, 2790 } } )
     else
      subCutin( { obj="@MPR_Player_1_0", voice={ 2770, 2780, 2790 } } )
     end
    else
     rnd = Rand(3)
     if ( rnd == 0 ) then
      talk = { 2790 }
     else
      talk = { 2770, 2780 }
     end
     if ( talk[1] == 2790 and GetUnitInfo( "@MPR_Player_1_0", 11 ) == "MADOKA" ) then
      subCutin( { obj="@MPR_Player_1_0", voice={ 2791 } } )
      subCutin( { obj="@MPR_Player_1_0", voice={ 2792 } } )
     else
      subCutin( { obj="@MPR_Player_1_0", voice=talk } )
     end
    end
    if ( subFriendship() >= 70 ) then
     if subMamiPlayer() then
      subCutin( { obj="@MPR_Player_2_0", voice={ 2860, 2870 } } )
     else
      subCutin( { obj="@MPR_Player_2_0", voice={ 2840, 2850 } } )
     end
    elseif ( subFriendship() >= 40 ) then
     if subMamiPlayer() then
      subCutin( { obj="@MPR_Player_2_0", voice={ 2820, 2830 } } )
     else
      subCutin( { obj="@MPR_Player_2_0", voice={ 2800, 2810 } } )
     end
    else
    end
   end
  end
  subDeleteCutin()
  _retry( EQWait )
  _retry( WaitElapsedTime, 10 )
  DeleteArk()
  _retry( WaitArk )
 end
 FadeOut( 2, 0, 1 )
 _retry( WaitTime, 2 )
 Special( "MUSIC_CONTINUE" )
 Special( "BLOCK_PAUSEMENU", 0 )
 Special( "MISSION_CLEAR" )
end
function EVENT_STAGE_CLEAR_PROLOGUE()
 Special( "INVALIDATE_GIMMICK", 1 )
 if ( BeginDemo( 16 ) ) then
  KillUnit( "ENEMY_ALL", 0, 1 )
  Special( "BLOCK_PAUSEMENU", 1 )
  Special( "UNBREAKABLE" )
  BattleGauge( 0 )
  DeleteArk()
  DeleteTimedArk()
  _retry( EQDelete )
  Music( -3 )
  FadeIn( 0, 0, 1 )
  _retry( WaitTime, 1.5 )
  FadeOut( 1.5, 0, 1 )
  _retry( WaitTime, 1.5 )
  EndDemo()
 end
 Special( "MUSIC_CONTINUE" )
 Special( "BLOCK_PAUSEMENU", 0 )
 Special( "MISSION_CLEAR" )
end
function DEMO_STAGE_START( cut )
 if cut == nil then
  cut = {
    { -133.8, 18.4, -29.6, -91.0, 5, 29.3 },
    { 0, 12, 0, 20, -170, -3, 0, -6 },
    { -119.1, 28.3, 119.0 }
  }
 end
 if ( GetSystemVar( 3 ) ~= 3 and
   BeginDemo( 1
               + 2
               + 8
               + 16 ) ) then
  subBeforeDemo()
  FadeIn( 0, 0 )
  ScreenMonochrome( 1, 0 )
  CreateArk( "ark_mission_start" )
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 10, 10, 0, 10 )
  Path( 0, 2,
     cut[1][1], cut[1][2] + 20, cut[1][3],
     0, 0, 10,
     0, cut[1][4], 0,
     0, 4, 0,
     0, 0, 0 )
  Path( 1, 1,
     cut[1][1], cut[1][2] + 20, cut[1][3],
     cut[1][1], cut[1][2] + 20 + 40, cut[1][3],
     0, 10 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_COUNTDOWN" )
  PauseBattle( 1 )
  _retry( WaitTime, 40/30 )
  SePlay( "SEID_STG_COUNTDOWN" )
  Path( 3, 6, 50, 50, 0, 10 )
  Path( 2, 5, -8, -8, 0, 10 )
  Path( 0, 0,
     cut[2][1], cut[2][2] + 10, cut[2][3] )
  Path( 1, 2,
     cut[2][1], cut[2][2] + 10, cut[2][3],
     0, 0, 30,
     0, cut[2][4], 0,
     0, 0, 0,
     0, 5, 0 )
  _retry( WaitTime, 40/30 )
  SePlay( "SEID_STG_COUNTDOWN" )
  local unit = "@MPR_Player_1_0"
  local p1pos = { GetUnitInfo( unit, 32 ),
      GetUnitInfo( unit, 33 ),
      GetUnitInfo( unit, 34 ),
      GetUnitInfo( unit, 35 ),
      GetUnitInfo( unit, 36 ),
      GetUnitInfo( unit, 37 ) }
  local cam = {
      look_x = p1pos[1],
      look_y = p1pos[2] + 13.5,
      look_z = p1pos[3],
      pos_x = p1pos[1] + 35.5 * math.sin( math.rad( p1pos[5] + 180 ) ),
      pos_y = p1pos[2] + 19.5,
      pos_z = p1pos[3] + 35.5 * math.cos( math.rad( p1pos[5] + 180 ) ),
      }
  Path( 3, 6, 45, 45, 0, 10 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0,
     cam.look_x, cam.look_y, cam.look_z )
  if CheckWayPoint( cut[3][1], cut[3][2], cut[3][3], cam.pos_x, cam.pos_y, cam.pos_z ) then
   Path( 1, 9,
      cut[3][1], cut[3][2], cut[3][3],
      cam.pos_x, cam.pos_y, cam.pos_z,
      3, 1.8 )
  else
   Path( 1, 0,
      cam.pos_x, cam.pos_y, cam.pos_z )
  end
  _retry( WaitTime, 50/30 )
  ScreenMonochrome( 0, 20/30 )
  SePlay( "SEID_STG_STAGE_START" )
  _retry( WaitArk )
  subAfterDemo()
  DeleteArk()
  PauseBattle( 0 )
  EndDemo( 0.5 )
 end
 subStartRoom()
end
AddEventTrigger( "COMBINATION_MAGIC", 80, "MAGICCOMB", "@MPR_Player_1_0" )
function COMBINATION_MAGIC()
 local unit = { "@MPR_Player_1_0", "@MPR_Player_2_0" }
 local unitchar = { GetUnitInfo( unit[1], 11 ), GetUnitInfo( unit[2], 11 ) }
 local talk = {}
 if subEQCheck(510) then
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  Special( "BLOCK_PAUSEMENU", 1 )
  if ( BeginDemo( 8 ) ) then
   subBeforeDemo()
   PauseBattle( 1 )
   CreateArk( "ark_battle_special_player" )
   if ( unitchar[2] == "MADOKA" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 750 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 740 }
    else
     talk = { 730 }
    end
   elseif ( unitchar[2] == "MAMI" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 810 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 800 }
    else
     talk = { 790 }
    end
   elseif ( unitchar[2] == "SAYAKA" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 870 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 860 }
    else
     talk = { 850 }
    end
   elseif ( unitchar[2] == "KYOKO" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 930 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 920 }
    else
     talk = { 910 }
    end
   elseif ( unitchar[2] == "HOMURA" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 990 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 980 }
    else
     talk = { 970 }
    end
   end
   _retry( EQVoice, unitchar[1] .. "V", talk )
   SeStop( -1 )
   _retry( WaitTime, 1/30 )
   SePlay( "SEID_STG_MAGIC_CUTIN" )
   _retry( EQWaitVoice )
   _retry( EQWait )
   CreateArk( "ark_battle_special_partner" )
   SePlay( "SEID_STG_MAGIC_CUTIN" )
   if ( unitchar[1] == "MADOKA" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 780 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 770 }
    else
     talk = { 760 }
    end
   elseif ( unitchar[1] == "MAMI" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 840 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 830 }
    else
     talk = { 820 }
    end
   elseif ( unitchar[1] == "SAYAKA" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 900 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 890 }
    else
     talk = { 880 }
    end
   elseif ( unitchar[1] == "KYOKO" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 960 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 950 }
    else
     talk = { 940 }
    end
   elseif ( unitchar[1] == "HOMURA" ) then
    if ( subFriendship() >= 70 ) then
     talk = { 1020 }
    elseif ( subFriendship() >= 40 ) then
     talk = { 1010 }
    else
     talk = { 1000 }
    end
   end
   _retry( EQVoice, unitchar[2] .. "V", talk )
   _retry( EQWaitVoice )
   _retry( EQWaitTime, 0.1 )
   _retry( EQWait )
   DeleteArk( "ark_battle_special_player" )
   DeleteArk( "ark_battle_special_partner" )
   _retry( WaitTime, 0.3 )
   if ( unitchar[1] == "MADOKA" ) then
    if( unitchar[2] == "MAMI" ) then
     talk = { 1081 }
    elseif( unitchar[2] == "SAYAKA" ) then
     talk = { 1031 }
    elseif( unitchar[2] == "KYOKO" ) then
     talk = { 1033 }
    elseif( unitchar[2] == "HOMURA" ) then
     talk = { 1032 }
    end
   elseif( unitchar[1] == "MAMI" ) then
    if ( unitchar[2] == "MADOKA" ) then
     talk = { 1081 }
    elseif( unitchar[2] == "SAYAKA" ) then
     talk = { 1082 }
    elseif( unitchar[2] == "KYOKO" ) then
     talk = { 1084 }
    elseif( unitchar[2] == "HOMURA" ) then
     talk = { 1083 }
    end
   elseif( unitchar[1] == "SAYAKA" ) then
    if ( unitchar[2] == "MADOKA" ) then
     talk = { 1031 }
    elseif( unitchar[2] == "MAMI" ) then
     talk = { 1082 }
    elseif( unitchar[2] == "KYOKO" ) then
     talk = { 1035 }
    elseif( unitchar[2] == "HOMURA" ) then
     talk = { 1034 }
    end
   elseif( unitchar[1] == "KYOKO" ) then
    if ( unitchar[2] == "MADOKA" ) then
     talk = { 1033 }
    elseif( unitchar[2] == "MAMI" ) then
     talk = { 1084 }
    elseif( unitchar[2] == "SAYAKA" ) then
     talk = { 1035 }
    elseif( unitchar[2] == "HOMURA" ) then
     talk = { 1036 }
    end
   elseif( unitchar[1] == "HOMURA" ) then
    if ( unitchar[2] == "MADOKA" ) then
     talk = { 1032 }
    elseif( unitchar[2] == "MAMI" ) then
     talk = { 1083 }
    elseif( unitchar[2] == "SAYAKA" ) then
     talk = { 1034 }
    elseif( unitchar[2] == "KYOKO" ) then
     talk = { 1036 }
    end
   end
   CreateArk( "ark_battle_special_twosome" )
   SePlay( "SEID_STG_MAGIC_ZOOM" )
   _retry( EQVoice, "MADOKAV", talk )
   _retry( EQWait )
   _retry( WaitArk, "ark_battle_special_twosome" )
   DeleteArk( "ark_battle_special_twosome" )
   PauseBattle( 0 )
   subAfterDemo()
   EndDemo()
  end
  Special( "BLOCK_PAUSEMENU", 0 )
 end
 Special( "EVENT_WAIT_FINISH" )
 SePlay( "SEID_STG_MAGIC_ATTACK" )
 if not G_TENSION_MAX then
  AddEventTrigger( "TENSION_MAX", 99, "TENSIONMAX" )
  G_TENSION_MAX = true
 end
end
function DEMO_APPEAR_WITCH( unit, state )
 local demo_mdl = false
 local unit2
 local witches = { "GERTRUD", "CHARLOTTE1", "CHARLOTTE2", "ELLY", "ELZAMARIA",
       "ISABELLE", "PATRICIA", "OCTAVIA1", "WALPURGIS", "OCTAVIA2" }
 local stage = GetSystemVar( -93 )
 local witches_se = 0
 if state then
 else
  state = "NORMAL"
 end
 for i = 1, table.maxn( witches ) do
  if string.match( GetUnitInfo( unit, 6 ), witches[i] ) then
   witches_se = 10000 + 20 * ( i - 1 )
   break
  end
 end
 if ( string.match( unit, "ELZAMARIA" ) or
   string.match( unit, "OCTAVIA" ) or
   string.match( unit, "WALPURGIS" ) ) then
  demo_mdl = true
 end
 local camera = "@EVOB_" .. string.gsub( GetUnitInfo( unit, 6),"MS_W_", "", 1 ) .. ":0"
 camera = string.gsub( camera, "_HYPER", "", 1 )
 camera = string.gsub( camera, "_PRO", "", 1 )
  camera = string.gsub( camera, "_SUB", "", 1 )
  camera = string.gsub( camera, "_BAD", "", 1 )
 if string.match( unit, "CHARLOTTE2" ) then
  if string.match( unit, "_SUB" ) then
   unit2 = "@MS_W_CHARLOTTE1_SUB:0"
  else
   unit2 = "@MS_W_CHARLOTTE1:0"
  end
 end
 FadeIn( 0/30, 0 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  CamFar( 20000 )
  if demo_mdl then
  elseif unit2 then
   CreateUnit( unit, 1, 1 )
   CreateUnit( unit2, 1, 1 )
  else
   CreateUnit( unit, 1, 1 )
  end
  CreateUnit( camera, 1, 1 )
  if string.match( unit, "ELZAMARIA" ) then
   Locate( camera, 0, 14, 0, 0, 0 )
  elseif demo_mdl then
   Locate( camera, 0, 0, 0, 0, 0 )
  else
   Locate( unit, 0, 0, 0, 0, 0 )
   Locate( camera, 0, 0, 0, 0, 0 )
  end
  CamAttach( camera, 0, "camera1" )
  if demo_mdl then
  elseif unit2 then
   SetMotion( unit, 0, 11000, 0, 0 )
   SetMotion( unit2, 0, 11020, 0, 0 )
  else
   SetMotion( unit, 0, 11000, 0, 0 )
  end
  SetMotion( camera, 0, 1, 0, 0 )
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  _retry( EQVoice, "MADOKAV", { witches_se } )
  _retry( WaitMotion, camera )
  if demo_mdl then
  elseif unit2 then
   SetMotion( unit, 1, 11000, 0 )
   SetMotion( unit2, 1, 11020, 0 )
  else
   SetMotion( unit, 1, 11000, 0 )
  end
  SetMotion( camera, 1, 1, 0 )
  PauseBattle( 1 )
  SePlay( "SEID_STG_WITCH_NAME" )
  if ( stage == "s320" or string.match( stage, "s38" ) ) then
   _retry( EQDelete )
   if string.match( GetUnitInfo( unit, 6 ), "ELZAMARIA" ) then
    ScreenNegapogi( 1, 0 )
   else
    ScreenHue( 1, 0, math.rad(180) )
   end
   Path( 3, 6, 20, 20, 0, 10 )
   _retry( WaitTime, 1 )
  else
   CreateArk( "ark_mission_boss_name" )
   _retry( WaitTime, 2 )
   DeleteArk()
  end
  subFadeOutIn()
  PauseBattle( 0 )
  ScreenHue( 0, 0, math.rad(0) )
  subAfterDemo()
  CamAttach( camera, 1 )
  EndDemo()
 end
 subStartRoom()
 local ppid = { GetUnitInfo( "@MPR_Player_1_0", 11 ),
       GetUnitInfo( "@MPR_Player_2_0", 11 ) }
 local talk = {}
 _retry( EQDelete )
 _retry( WaitTime, 1/30 )
 if subEQCheck(400) then
  if ( stage == "s102" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3830 } } )
   subCutin( { obj="SAYAKA2", voice={ 3820 }, face=1 } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3840 }, open=true } )
  elseif ( stage == "s104" ) then
   subCutin( { obj="MADOKA2", voice={ 3850 }, face=0 } )
   _retry( EQWaitTime, 0.5 )
   subCutin( { obj="MADOKA2", voice={ 3860 }, face=0 } )
   subCutin( { obj="MADOKA2", voice={ 3870 }, face=0 } )
  elseif ( stage == "s055" and
     GetUnitInfo( "@MPR_Player_1_0", 11 ) == "MAMI" and
     GetUnitInfo( "@MPR_Player_2_0", 11 ) == "KYOKO" ) then
   subCutin( { obj="@MPR_Player_1_0", voice={ 3920 } } )
   subCutin( { obj="@MPR_Player_2_0", voice={ 3920 } } )
  elseif ( stage == "s055" and
     GetUnitInfo( "@MPR_Player_1_0", 11 ) == "KYOKO" and
     GetUnitInfo( "@MPR_Player_2_0", 11 ) == "MAMI" ) then
   subCutin( { obj="@MPR_Player_2_0", voice={ 3920 } } )
   subCutin( { obj="@MPR_Player_1_0", voice={ 3920 } } )
  else
   if string.match( unit, "WALPURGIS" ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 3310 } } )
   elseif string.match( state, "SERIES" ) then
   else
    subCutin( { obj="@MPR_Player_1_0", voice={ 2360, 2370, 2380 } } )
   end
   if ( subStoryModeCheck() or subFriendship() >= 70 ) then
    if string.match( unit, "GERTRUD" ) then
     talk = { 2690 }
    elseif string.match( unit, "CHARLOTTE1" ) then
     talk = { 2700 }
    elseif string.match( unit, "CHARLOTTE2" ) then
     talk = { 2710 }
    elseif string.match( unit, "ELLY" ) then
     talk = { 2720 }
    elseif string.match( unit, "ELZAMARIA" ) then
     talk = { 2730 }
    elseif string.match( unit, "OCTAVIA" ) then
     talk = { 2740 }
    elseif string.match( unit, "ISABELLE" ) then
     talk = { 2750 }
    elseif string.match( unit, "PATRICIA" ) then
     talk = { 2760 }
    elseif string.match( unit, "WALPURGIS" ) then
     talk = { 3320 }
    end
    if ( GetUnitInfo( "@MPR_Player_2_0", 0 ) > 0 ) then
     if ( talk[1] == 2700 and ppid[2] == "MADOKA" ) then
      subCutin( { obj="@MPR_Player_2_0", voice={ 2701 } } )
      subCutin( { obj="@MPR_Player_2_0", voice={ 2702 } } )
     elseif ( talk[1] == 2730 and ppid[2] == "HOMURA" ) then
      subCutin( { obj="@MPR_Player_2_0", voice={ 2731 } } )
      subCutin( { obj="@MPR_Player_2_0", voice={ 2732 } } )
     elseif ( talk[1] == 3320 and
        ( ( ppid[2] == "MADOKA" ) or
          ( ppid[2] == "SAYAKA" ) or
          ( ppid[2] == "HOMURA" ) ) ) then
      subCutin( { obj="@MPR_Player_2_0", voice={ 3321 } } )
      subCutin( { obj="@MPR_Player_2_0", voice={ 3322 } } )
     else
      subCutin( { obj="@MPR_Player_2_0", voice=talk } )
     end
    else
     if string.match( unit, "WALPURGIS" ) then
     else
      subCutin( { obj="KYUBEY", voice=talk } )
     end
    end
   else
    if string.match( state, "SERIES" ) then
    elseif ( GetUnitInfo( "@MPR_Player_2_0", 0 ) <= 0 ) then
     if string.match( unit, "WALPURGIS" ) then
     else
      subCutin( { obj="KYUBEY", voice={ 2390, 2400 } } )
     end
    else
     if subMamiPlayer() then
      subCutin( { obj="@MPR_Player_2_0", voice={ 2410, 2420 } } )
     else
      subCutin( { obj="@MPR_Player_2_0", voice={ 2390, 2400 } } )
     end
    end
   end
  end
  subDeleteCutin()
 end
end
function DEMO_APPEAR_MIDDLE( unit, state )
 local center = GetUnitInfo( unit[1], 6 )
 local cam = {}
 local rot_z = 0
 local cam_x = 0
 if state then
 else
  SeStop( -1 )
  Music( -3 )
  EndHomuraTimeStop()
  _retry( WaitTime, 1/30 )
 end
 if ( BeginDemo() ) then
  subBeforeDemo()
  Music( "BGM_STAGE_MIDDLE_" .. GetSystemVar( -99 ) )
  SePlay( "SEID_STG_APPEAR_ENEMY" )
  SePlay( "SEID_STG_JINGLE_MINUS" )
  for i = 1, table.maxn( unit ) do
   CreateUnit( unit[i] )
  end
  if string.match( center, "DANIYYEL" ) then
   Locate( unit[2], "PARENT_Y", unit[1], 16, 0, 0, 0, 0 )
  elseif string.match( center, "JENNIFE" ) then
   Locate( unit[2], "PARENT_Y", unit[1], -16, 0, 0, 0, 0 )
  end
  if string.match( center, "ANTHONY" ) then
   cam = { 7.7 * 2, 19.9 * 2 }
  elseif string.match( center, "SMALLADELBERT" ) then
   cam = { 8.1 * 2, 21.9 * 2 }
  elseif string.match( center, "BIGADELBERT" ) then
   cam = { 11.4 * 2, 26.9 * 2 }
  elseif string.match( center, "PYOTR" ) then
   cam = { 4.4 * 2, 27.1 * 2 }
  elseif string.match( center, "NURSE" ) then
   cam = { 13 * 1.5, 33.1 * 1.5 }
  elseif string.match( center, "DANIYYEL" ) then
   cam = { 8.9 * 2, 25.3 * 2 }
   cam_x = 8
  elseif string.match( center, "JENNIFE" ) then
   cam = { 8.9 * 2, 25.3 * 2 }
   cam_x = -8
  elseif string.match( center, "TVHEAD" ) then
   cam = { 8.9 * 1.5, 22.2 * 1.5 }
  elseif string.match( center, "SEBASTIANSA" ) then
   cam = { 12 * 2, 37.9 * 2 }
  elseif string.match( center, "SEBASTIANSB" ) then
   cam = { 8.6 * 2, 37.7 * 2 }
  elseif string.match( center, "HOLGER" ) then
   cam = { 11.5 * 2, 42 * 2 }
  elseif string.match( center, "CLARISSA" ) then
   cam = { 10.7 * 2, 34.2 * 2 }
  elseif string.match( center, "WHEEL" ) then
   cam = { 15.6 * 2, 54.5 * 2 }
   rot_z = 90
  elseif string.match( center, "MICHAELAA" ) then
   cam = { 11.5 * 2, 36.8 * 2 }
  elseif string.match( center, "MICHAELAB" ) then
   cam = { 8 * 3, 24.9 * 3 }
  elseif string.match( center, "MATHIEUB" ) then
   cam = { 11.3 * 2, 26.9 * 2 }
  elseif string.match( center, "MATHIEU" ) then
   cam = { 6 * 2, 26.6 * 2 }
  else
   cam = { 15, 40 }
  end
  Path( 3, 6, 60, 55, 0, 3 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit[1],
     cam_x, cam[1], 0 )
  Path( 1, 2, "PARENT_Y", unit[1],
     cam_x, cam[1], 0,
     0, 0, cam[2],
     0, 0, rot_z,
     0, 0, 0,
     0, 0, 0 )
  _retry( WaitElapsedTime, 2.2 )
  local plus = { x=Rand(4)+3, y=Rand(4)+3, r=Rand(10)+10 }
  if ( Rand(2) <= 0 ) then plus.x = plus.x * -1 end
  if ( Rand(2) <= 0 ) then plus.y = plus.y * -1 end
  if ( Rand(2) <= 0 ) then plus.r = plus.r * -1 end
  PauseBattle( 1 )
  Path( 2, 5, plus.r, plus.r, 0, 10 )
  Path( 3, 6, 25, 25, 0, 2 )
  Path( 0, 0, "PARENT_Y", unit[1],
     plus.x + cam_x, cam[1], plus.y )
  Path( 1, 2, "PARENT_Y", unit[1],
     plus.x + cam_x, cam[1], plus.y,
     0, 0, cam[2],
     0, 0, rot_z,
     0, 0, 0,
     0, 0, 0 )
  if subUnitElzaCheck( unit[1] ) then
   ScreenNegapogi( 1, 0 )
  else
   ScreenHue( 1, 0, math.rad(180) )
  end
  SePlay( "SEID_STG_WITCH_NAME" )
  _retry( WaitTime, 1.5 )
  if subUnitElzaCheck( unit[1] ) then
   ScreenNegapogi( 0, 0 )
  else
   ScreenHue( 0, 0, math.rad(0) )
  end
  PauseBattle( 0 )
  subAfterDemo()
  EndDemo()
 end
 if subEQCheck(670) then
  subCutin( { obj= "@MPR_Player_1_0", voice={ 2240, 2250, 2260 } } )
  subDeleteCutin()
 end
end
function subGetMinAndSec( time )
 local min = math.floor( time / 60 )
 local sec = time % 60
 return min, sec
end
function subStartRoom()
 if ( string.find( GetSystemVar( -94 ), "s10" ) ~= nil and
   GetUnitInfo( "@MPR_Player_1_0", 55 ) <= 0 ) then
  SetUnitInfo( "@MPR_Player_1_0", 1, 1 )
 end
end
function subFriendship()
 local f_point = 0
 if ( GetUnitInfo( "@MPR_Player_2_0", 11 ) ~= "" ) then
  f_point = GetFriendship( GetUnitInfo( "@MPR_Player_1_0", 11 ),
         GetUnitInfo( "@MPR_Player_2_0", 11 ) )
 end
 return f_point
end
function subMamiPlayer()
 local talk = false
 local ppid = { GetUnitInfo( "@MPR_Player_1_0", 11 ),
       GetUnitInfo( "@MPR_Player_2_0", 11 ) }
 if ( ppid[1] == "MAMI" and
   ( ppid[2] == "MADOKA" or ppid[2] == "SAYAKA" ) ) then
  talk = true
 end
 return talk
end
function subMamiPartner()
 local talk = false
 local ppid = { GetUnitInfo( "@MPR_Player_1_0", 11 ),
       GetUnitInfo( "@MPR_Player_2_0", 11 ) }
 if ( ppid[2] == "MAMI" and
   ( ppid[1] == "MADOKA" or ppid[1] == "SAYAKA" ) ) then
  talk = true
 end
 return talk
end
G_EQ_PRIORITY = 1000
function subEQCheck( eqpri )
 local eqstate = false
 print( "NNNNNNNNNN eqpri         : " .. eqpri )
 print( "NNNNNNNNNN G_EQ_PRIORITY : " .. G_EQ_PRIORITY )
 if not CheckBusy() then
  eqstate = true
  G_EQ_PRIORITY = eqpri
 elseif G_EQ_PRIORITY > eqpri then
  _retry( EQDelete )
  _retry( WaitTime, 1/30 )
  eqstate = true
  G_EQ_PRIORITY = eqpri
 elseif G_EQ_PRIORITY == eqpri then
  eqstate = true
 end
 return eqstate
end
function subWitchCheck()
 local stage_witch = { "s015", "s016", "s017", "s023", "s024",
        "s025", "s026", "s030", "s031", "s032", "s033",
        "s034", "s035", "s036", "s037", "s050", "s051",
        "s052", "s053", "s054", "s055", "s056", "s057",
        "s070", "s071", "s072", "s073", "s074", "s076",
        "s077", "s078", "s079", "s080", "s081", "s082",
        "s083", "s084", "s085", "s086", "s087", "s088",
        "s089", "s090", "s102", "s104", "s105", "s111",
        "s112", "s114", "s115", "s300", "s301", "s302",
        "s303", "s304", "s305", "s320", "s340", "s341",
        "s342", "s350", "s351", "s352", "s353", "s354",
        "s355", "s356", "s357", "s358", "s359", "s380",
        "s381", "s390", "s391", "s500", "s501", "s502",
        "s503", "s504", "s505", "s506", "s507", "s508" }
 local check = false
 for i = 0, table.maxn( stage_witch ) do
  if ( GetSystemVar( -93 ) == stage_witch[i] ) then
   check = true
   break
  end
 end
 return check
end
function subStoryModeCheck()
 local stage_story = { "s100", "s101", "s102", "s103", "s104", "s105",
        "s110", "s111", "s112", "s113", "s114", "s115",
        "s010", "s011", "s012", "s013", "s014", "s015", "s016", "s017",
        "s020", "s021", "s022", "s023", "s024", "s025", "s026",
        "s030", "s031", "s032", "s033", "s034", "s035", "s036", "s037",
        "s050", "s051", "s052", "s053", "s054", "s055", "s056", "s057",
        "s070", "s071", "s072", "s073", "s074", "s075", "s076", "s077", "s078", "s079",
        "s080", "s081", "s082", "s083", "s084", "s085", "s086", "s087", "s088", "s089",
        "s090" }
 local check = false
 for i = 0, table.maxn( stage_story ) do
  if ( GetSystemVar( -93 ) == stage_story[i] ) then
   check = true
   break
  end
 end
 return check
end
function subPrologueCheck()
 local stage = { "s100", "s101", "s102", "s103", "s104", "s105" }
 local check = false
 for i = 0, table.maxn( stage ) do
  if ( GetSystemVar( -93 ) == stage[i] ) then
   check = true
   break
  end
 end
 return check
end
function subMockCheck()
 local stage = GetSystemVar( -93 )
 local mock_stage = { "s200", "s201", "s202", "s203", "s204", "s205", "s206",
       "s370", "s371", "s372", "s373", "s374" }
 local mock = false
 for i = 1, table.maxn( mock_stage ) do
  if stage == mock_stage[i] then
   mock = true
   break
  end
 end
 return mock
end
function subDoorCheck( unit )
 local door = { "OB_ELLY_DOOR_02", "OB_ELSA_DOOR_01", "OB_ELSA_DOOR_02",
       "OB_ELSA_DOOR_03", "OB_ELSA_DOOR_04", "OB_OKTA_DOOR_02",
       "OB_IZAB_DOOR_01", "OB_PATR_DOOR_01" }
 local door_flag = true
 unit = GetUnitInfo( unit, 6 )
 for i = 1, table.maxn( door ) do
  if string.match( unit, door[i] ) then
   door_flag = false
   break
  end
 end
 return door_flag
end
function subUnitElzaCheck( unit )
 local unitelza = { "MS_S_SEBASTIANSA", "MS_S_SEBASTIANSB", "MS_W_ELZAMARIA" }
 local flag = false
 unitid = GetUnitInfo( unit, 6 )
 for i = 1, table.maxn( unitelza ) do
  if string.match( unit, unitelza[i] ) then
   flag = true
   break
  end
 end
 return flag
end
G_FACETYPE = {
 {
  { 10, 3 },
  { 20, 0 },
  { 30, 0 },
  { 40, 1 },
  { 50, 1 },
  { 60, 1 },
  { 70, 1 },
  { 80, 0 },
  { 90, 3 },
  { 100, 3 },
  { 110, 0 },
  { 120, 3 },
  { 130, 0 },
  { 140, 0 },
  { 150, 0 },
  { 160, 0 },
  { 170, 2 },
  { 180, 3 },
  { 190, 3 },
  { 200, 3 },
  { 210, 3 },
  { 220, 0 },
  { 230, 3 },
  { 240, 3 },
  { 250, 2 },
  { 260, 1 },
  { 270, 3 },
  { 280, 3 },
  { 290, 3 },
  { 300, 3 },
  { 310, 3 },
  { 320, 3 },
  { 330, 0 },
  { 340, 0 },
  { 350, 0 },
  { 360, 0 },
  { 370, 2 },
  { 380, 2 },
  { 390, 3 },
  { 400, 3 },
  { 401, 3 },
  { 410, 3 },
  { 420, 3 },
  { 430, 2 },
  { 440, 2 },
  { 450, 2 },
  { 460, 0 },
  { 470, 1 },
  { 480, 2 },
  { 490, 2 },
  { 500, 2 },
  { 510, 3 },
  { 520, 2 },
  { 530, 2 },
  { 540, 2 },
  { 550, 2 },
  { 560, 2 },
  { 570, 2 },
  { 580, 2 },
  { 590, 2 },
  { 600, 2 },
  { 610, 2 },
  { 620, 2 },
  { 630, 2 },
  { 640, 2 },
  { 650, 2 },
  { 660, 2 },
  { 670, 2 },
  { 680, 0 },
  { 690, 3 },
  { 700, 0 },
  { 710, 2 },
  { 720, 2 },
  { 790, 2 },
  { 800, 2 },
  { 810, 2 },
  { 820, 2 },
  { 830, 2 },
  { 840, 2 },
  { 850, 2 },
  { 860, 0 },
  { 870, 2 },
  { 880, 2 },
  { 890, 0 },
  { 900, 1 },
  { 910, 2 },
  { 920, 0 },
  { 930, 2 },
  { 940, 2 },
  { 950, 2 },
  { 960, 2 },
  { 970, 0 },
  { 980, 2 },
  { 990, 2 },
  { 1000, 2 },
  { 1010, 0 },
  { 1020, 1 },
  { 1030, 2 },
  { 1031, 2 },
  { 1032, 2 },
  { 1033, 2 },
  { 1034, 2 },
  { 1035, 2 },
  { 1036, 2 },
  { 1080, 2 },
  { 1081, 2 },
  { 1082, 2 },
  { 1083, 2 },
  { 1084, 2 },
  { 1090, 2 },
  { 1100, 3 },
  { 1110, 3 },
  { 1120, 3 },
  { 1130, 3 },
  { 1140, 3 },
  { 1150, 3 },
  { 1160, 2 },
  { 1170, 0 },
  { 1180, 0 },
  { 1190, 2 },
  { 1200, 0 },
  { 1210, 2 },
  { 1220, 0 },
  { 1230, 2 },
  { 1240, 2 },
  { 1250, 2 },
  { 1260, 2 },
  { 1270, 0 },
  { 1280, 0 },
  { 1290, 2 },
  { 1300, 3 },
  { 1310, 3 },
  { 1320, 3 },
  { 1330, 3 },
  { 1340, 3 },
  { 1350, 3 },
  { 1360, 3 },
  { 1370, 3 },
  { 1390, 2 },
  { 1400, 2 },
  { 1410, 2 },
  { 1420, 2 },
  { 1430, 2 },
  { 1440, 2 },
  { 1450, 1 },
  { 1460, 1 },
  { 1470, 3 },
  { 1480, 0 },
  { 1490, 1 },
  { 1500, 0 },
  { 1510, 1 },
  { 1520, 1 },
  { 1530, 1 },
  { 1540, 1 },
  { 1550, 3 },
  { 1560, 1 },
  { 1570, 1 },
  { 1580, 3 },
  { 1590, 2 },
  { 1600, 2 },
  { 1610, 2 },
  { 1620, 2 },
  { 1630, 2 },
  { 1640, 1 },
  { 1650, 2 },
  { 1660, 2 },
  { 1670, 2 },
  { 1680, 2 },
  { 1690, 3 },
  { 1700, 3 },
  { 1710, 0 },
  { 1720, 0 },
  { 1730, 2 },
  { 1740, 2 },
  { 1750, 2 },
  { 1760, 0 },
  { 1770, 3 },
  { 1780, 3 },
  { 1790, 1 },
  { 1800, 1 },
  { 1810, 1 },
  { 1820, 1 },
  { 1830, 0 },
  { 1840, 1 },
  { 1850, 0 },
  { 1860, 1 },
  { 1870, 0 },
  { 1880, 1 },
  { 1890, 2 },
  { 1900, 2 },
  { 1910, 3 },
  { 1920, 3 },
  { 1930, 0 },
  { 1940, 0 },
  { 1950, 0 },
  { 1960, 3 },
  { 1970, 3 },
  { 1980, 0 },
  { 1990, 0 },
  { 2000, 0 },
  { 2010, 3 },
  { 2020, 0 },
  { 2030, 0 },
  { 2040, 1 },
  { 2050, 0 },
  { 2060, 1 },
  { 2070, 0 },
  { 2080, 1 },
  { 2090, 1 },
  { 2100, 3 },
  { 2110, 0 },
  { 2120, 0 },
  { 2130, 3 },
  { 2140, 3 },
  { 2150, 0 },
  { 2160, 3 },
  { 2170, 0 },
  { 2180, 2 },
  { 2190, 2 },
  { 2200, 3 },
  { 2210, 3 },
  { 2220, 3 },
  { 2230, 3 },
  { 2240, 0 },
  { 2250, 0 },
  { 2260, 3 },
  { 2270, 1 },
  { 2280, 0 },
  { 2290, 1 },
  { 2300, 1 },
  { 2310, 1 },
  { 2320, 1 },
  { 2330, 1 },
  { 2340, 1 },
  { 2350, 1 },
  { 2360, 0 },
  { 2370, 0 },
  { 2380, 2 },
  { 2390, 2 },
  { 2400, 0 },
  { 2410, 0 },
  { 2420, 2 },
  { 2430, 0 },
  { 2440, 0 },
  { 2450, 0 },
  { 2460, 2 },
  { 2470, 2 },
  { 2480, 2 },
  { 2490, 2 },
  { 2500, 0 },
  { 2510, 0 },
  { 2520, 0 },
  { 2530, 1 },
  { 2540, 1 },
  { 2550, 1 },
  { 2560, 1 },
  { 2570, 0 },
  { 2580, 3 },
  { 2590, 2 },
  { 2600, 2 },
  { 2610, 2 },
  { 2620, 0 },
  { 2630, 3 },
  { 2640, 3 },
  { 2650, 2 },
  { 2660, 2 },
  { 2670, 0 },
  { 2680, 2 },
  { 2690, 0 },
  { 2700, 1 },
  { 2701, 1 },
  { 2702, 0 },
  { 2710, 2 },
  { 2720, 0 },
  { 2730, 0 },
  { 2740, 3 },
  { 2750, 0 },
  { 2760, 3 },
  { 2770, 1 },
  { 2780, 1 },
  { 2790, 0 },
  { 2791, 0 },
  { 2792, 1 },
  { 2800, 1 },
  { 2810, 1 },
  { 2820, 1 },
  { 2830, 1 },
  { 2840, 1 },
  { 2850, 0 },
  { 2860, 1 },
  { 2870, 1 },
  { 2880, 1 },
  { 2890, 0 },
  { 2900, 1 },
  { 2910, 0 },
  { 2920, 0 },
  { 2930, 1 },
  { 2940, 0 },
  { 2950, 1 },
  { 2960, 1 },
  { 2970, 1 },
  { 2980, 0 },
  { 2990, 0 },
  { 3000, 3 },
  { 3010, 0 },
  { 3020, 3 },
  { 3030, 0 },
  { 3040, 1 },
  { 3050, 1 },
  { 3060, 1 },
  { 3070, 1 },
  { 3080, 1 },
  { 3090, 0 },
  { 3100, 2 },
  { 3110, 1 },
  { 3120, 1 },
  { 3130, 3 },
  { 3140, 3 },
  { 3200, 0 },
  { 3210, 1 },
  { 3220, 2 },
  { 3221, 2 },
  { 3222, 1 },
  { 3230, 2 },
  { 3250, 0 },
  { 3260, 0 },
  { 3270, 0 },
  { 3280, 0 },
  { 3290, 0 },
  { 3300, 2 },
  { 3310, 0 },
  { 3320, 3 },
  { 3321, 3 },
  { 3322, 2 },
  { 3330, 2 },
  { 3340, 1 },
  { 3341, 1 },
  { 3342, 2 },
  { 3350, 2 },
  { 3370, 1 },
  { 3380, 1 },
  { 3390, 1 },
  { 3400, 1 },
  { 3410, 1 },
  { 3420, 2 },
  { 3430, 2 },
  { 3440, 2 },
  { 3441, 2 },
  { 3450, 2 },
  { 3451, 2 },
  { 3452, 2 },
  { 3453, 2 },
  { 3454, 2 },
  { 3455, 2 },
  { 3460, 3 },
  { 3470, 2 },
  { 3480, 2 },
  { 3490, 2 },
  { 3500, 3 },
  { 3501, 3 },
  { 3502, 2 },
  { 3510, 0 },
  { 3520, 2 },
  { 3530, 2 },
  { 3540, 2 },
  { 3550, 2 },
  { 3560, 3 },
  { 3570, 2 },
  { 3580, 2 },
  { 3590, 2 },
  { 3600, 2 },
  { 3610, 2 },
  { 3620, 2 },
  { 3630, 2 },
  { 3640, 2 },
  { 3650, 2 },
  { 3660, 2 },
  { 3670, 2 },
  { 3680, 2 },
  { 3690, 2 },
  { 3700, 2 },
  { 3710, 2 },
  { 3720, 2 },
  { 3730, 2 },
  { 3740, 2 },
  { 3750, 2 },
  { 3760, 2 },
  { 3770, 2 },
  { 3780, 2 },
  { 3790, 2 },
  { 3800, 2 },
  { 3810, 2 },
  { 3820, 1 },
  { 3830, 1 },
  { 3840, 3 },
  { 3850, 0 },
  { 3860, 0 },
  { 3870, 0 },
  { 3880, 0 },
  { 3890, 0 },
  { 3900, 0 },
  { 3910, 0 },
  { 3920, 1 },
  { 3930, 1 },
  { 3940, 1 },
  { 3950, 1 },
  { 3960, 1 },
  { 3970, 0 },
  { 3980, 0 },
  { 3990, 3 },
  { 4000, 0 },
  { 4010, 0 },
  { 4011, 0 },
  { 4012, 1 },
  { 4020, 0 },
  { 4030, 3 },
  { 4040, 0 },
  { 4041, 0 },
  { 4042, 2 },
  { 5390, 0 }
 },
 {
  { 10, 1 },
  { 20, 1 },
  { 30, 2 },
  { 40, 1 },
  { 50, 0 },
  { 51, 0 },
  { 52, 1 },
  { 60, 1 },
  { 70, 1 },
  { 80, 2 },
  { 90, 1 },
  { 100, 0 },
  { 110, 1 },
  { 120, 0 },
  { 130, 1 },
  { 140, 0 },
  { 150, 1 },
  { 160, 1 },
  { 170, 1 },
  { 180, 0 },
  { 190, 2 },
  { 200, 2 },
  { 210, 2 },
  { 220, 2 },
  { 230, 0 },
  { 240, 0 },
  { 250, 2 },
  { 260, 2 },
  { 270, 3 },
  { 280, 3 },
  { 290, 3 },
  { 300, 3 },
  { 310, 3 },
  { 320, 3 },
  { 330, 2 },
  { 340, 2 },
  { 350, 2 },
  { 360, 2 },
  { 370, 2 },
  { 380, 2 },
  { 390, 3 },
  { 391, 3 },
  { 400, 3 },
  { 401, 3 },
  { 410, 3 },
  { 420, 2 },
  { 430, 2 },
  { 440, 2 },
  { 450, 2 },
  { 460, 2 },
  { 470, 2 },
  { 480, 2 },
  { 490, 2 },
  { 500, 2 },
  { 510, 2 },
  { 520, 1 },
  { 530, 2 },
  { 540, 2 },
  { 550, 2 },
  { 560, 2 },
  { 570, 2 },
  { 580, 2 },
  { 590, 2 },
  { 600, 2 },
  { 610, 2 },
  { 620, 2 },
  { 630, 2 },
  { 640, 2 },
  { 650, 2 },
  { 660, 2 },
  { 670, 2 },
  { 680, 1 },
  { 690, 2 },
  { 700, 0 },
  { 710, 0 },
  { 720, 0 },
  { 730, 1 },
  { 740, 1 },
  { 750, 2 },
  { 760, 2 },
  { 770, 1 },
  { 780, 1 },
  { 790, 2 },
  { 800, 1 },
  { 810, 2 },
  { 820, 2 },
  { 830, 2 },
  { 840, 1 },
  { 910, 2 },
  { 920, 2 },
  { 930, 2 },
  { 940, 2 },
  { 950, 1 },
  { 960, 1 },
  { 970, 2 },
  { 980, 2 },
  { 990, 2 },
  { 1000, 2 },
  { 1010, 1 },
  { 1020, 2 },
  { 1030, 2 },
  { 1080, 2 },
  { 1090, 3 },
  { 1100, 3 },
  { 1110, 3 },
  { 1120, 3 },
  { 1130, 3 },
  { 1140, 3 },
  { 1150, 3 },
  { 1160, 2 },
  { 1170, 0 },
  { 1180, 2 },
  { 1190, 2 },
  { 1200, 2 },
  { 1210, 2 },
  { 1220, 2 },
  { 1230, 2 },
  { 1240, 2 },
  { 1250, 2 },
  { 1260, 2 },
  { 1270, 3 },
  { 1280, 2 },
  { 1290, 2 },
  { 1300, 0 },
  { 1310, 0 },
  { 1320, 0 },
  { 1330, 3 },
  { 1340, 3 },
  { 1350, 3 },
  { 1360, 3 },
  { 1370, 3 },
  { 1380, 2 },
  { 1400, 2 },
  { 1410, 2 },
  { 1420, 3 },
  { 1430, 1 },
  { 1440, 0 },
  { 1450, 1 },
  { 1460, 1 },
  { 1470, 0 },
  { 1480, 2 },
  { 1490, 0 },
  { 1500, 0 },
  { 1510, 3 },
  { 1520, 3 },
  { 1530, 1 },
  { 1540, 1 },
  { 1550, 1 },
  { 1560, 0 },
  { 1570, 1 },
  { 1580, 0 },
  { 1590, 3 },
  { 1600, 3 },
  { 1610, 1 },
  { 1620, 1 },
  { 1630, 1 },
  { 1640, 1 },
  { 1650, 2 },
  { 1660, 2 },
  { 1670, 2 },
  { 1680, 2 },
  { 1690, 3 },
  { 1700, 3 },
  { 1710, 2 },
  { 1720, 2 },
  { 1730, 0 },
  { 1740, 2 },
  { 1750, 0 },
  { 1760, 2 },
  { 1770, 3 },
  { 1780, 3 },
  { 1790, 1 },
  { 1800, 1 },
  { 1810, 1 },
  { 1820, 1 },
  { 1830, 0 },
  { 1840, 1 },
  { 1850, 0 },
  { 1860, 1 },
  { 1870, 0 },
  { 1880, 1 },
  { 1890, 2 },
  { 1900, 0 },
  { 1910, 0 },
  { 1920, 0 },
  { 1930, 1 },
  { 1940, 0 },
  { 1950, 3 },
  { 1960, 0 },
  { 1970, 0 },
  { 1980, 3 },
  { 1990, 1 },
  { 2000, 0 },
  { 2010, 0 },
  { 2020, 0 },
  { 2030, 0 },
  { 2040, 1 },
  { 2050, 0 },
  { 2060, 1 },
  { 2070, 0 },
  { 2080, 0 },
  { 2090, 1 },
  { 2100, 2 },
  { 2110, 3 },
  { 2120, 0 },
  { 2130, 2 },
  { 2140, 2 },
  { 2150, 2 },
  { 2160, 3 },
  { 2170, 2 },
  { 2180, 0 },
  { 2190, 1 },
  { 2200, 3 },
  { 2210, 3 },
  { 2220, 3 },
  { 2230, 3 },
  { 2240, 3 },
  { 2250, 0 },
  { 2260, 0 },
  { 2270, 0 },
  { 2280, 0 },
  { 2290, 0 },
  { 2300, 1 },
  { 2310, 1 },
  { 2320, 0 },
  { 2330, 1 },
  { 2340, 1 },
  { 2350, 0 },
  { 2360, 2 },
  { 2370, 2 },
  { 2380, 2 },
  { 2390, 0 },
  { 2400, 0 },
  { 2410, 2 },
  { 2420, 2 },
  { 2430, 1 },
  { 2440, 0 },
  { 2450, 0 },
  { 2460, 1 },
  { 2470, 1 },
  { 2480, 1 },
  { 2490, 2 },
  { 2500, 0 },
  { 2501, 0 },
  { 2502, 1 },
  { 2510, 1 },
  { 2520, 0 },
  { 2530, 1 },
  { 2540, 1 },
  { 2550, 1 },
  { 2560, 1 },
  { 2570, 0 },
  { 2580, 0 },
  { 2590, 2 },
  { 2600, 2 },
  { 2610, 2 },
  { 2620, 2 },
  { 2630, 0 },
  { 2640, 2 },
  { 2650, 2 },
  { 2660, 1 },
  { 2670, 2 },
  { 2680, 1 },
  { 2690, 3 },
  { 2700, 0 },
  { 2710, 2 },
  { 2720, 2 },
  { 2730, 2 },
  { 2740, 0 },
  { 2750, 0 },
  { 2760, 3 },
  { 2770, 1 },
  { 2780, 1 },
  { 2790, 1 },
  { 2800, 1 },
  { 2810, 1 },
  { 2820, 1 },
  { 2830, 1 },
  { 2840, 1 },
  { 2850, 1 },
  { 2860, 0 },
  { 2870, 0 },
  { 2880, 1 },
  { 2890, 1 },
  { 2900, 1 },
  { 2910, 0 },
  { 2920, 1 },
  { 2930, 1 },
  { 2940, 1 },
  { 2950, 1 },
  { 2960, 1 },
  { 2970, 0 },
  { 2980, 0 },
  { 2990, 0 },
  { 3000, 3 },
  { 3010, 3 },
  { 3020, 0 },
  { 3030, 3 },
  { 3040, 1 },
  { 3050, 1 },
  { 3060, 1 },
  { 3070, 1 },
  { 3080, 0 },
  { 3090, 2 },
  { 3100, 1 },
  { 3110, 1 },
  { 3120, 1 },
  { 3130, 0 },
  { 3140, 3 },
  { 3200, 2 },
  { 3210, 0 },
  { 3220, 2 },
  { 3230, 1 },
  { 3231, 1 },
  { 3232, 2 },
  { 3240, 2 },
  { 3260, 1 },
  { 3270, 0 },
  { 3280, 0 },
  { 3290, 0 },
  { 3300, 2 },
  { 3310, 3 },
  { 3320, 3 },
  { 3321, 3 },
  { 3322, 2 },
  { 3330, 1 },
  { 3340, 0 },
  { 3341, 0 },
  { 3342, 2 },
  { 3350, 2 },
  { 3360, 1 },
  { 3380, 1 },
  { 3390, 2 },
  { 3400, 1 },
  { 3410, 2 },
  { 3420, 1 },
  { 3430, 2 },
  { 3440, 2 },
  { 3441, 2 },
  { 3450, 2 },
  { 3451, 2 },
  { 3452, 2 },
  { 3460, 3 },
  { 3461, 3 },
  { 3462, 2 },
  { 3470, 2 },
  { 3480, 1 },
  { 3490, 2 },
  { 3500, 1 },
  { 3510, 1 },
  { 3520, 0 },
  { 3530, 3 },
  { 3540, 2 },
  { 3550, 2 },
  { 3560, 3 },
  { 3820, 1 },
  { 3830, 2 },
  { 3840, 0 },
  { 3850, 1 },
  { 3860, 0 },
  { 3870, 0 },
  { 3880, 2 },
  { 3890, 0 },
  { 3900, 2 },
  { 3910, 2 },
  { 3920, 2 },
  { 3930, 3 },
  { 3940, 2 },
  { 3950, 0 },
  { 3960, 0 },
  { 3961, 0 },
  { 3962, 1 },
  { 5390, 0 }
 },
 {
  { 10, 0 },
  { 20, 0 },
  { 30, 1 },
  { 40, 1 },
  { 50, 1 },
  { 60, 0 },
  { 70, 2 },
  { 80, 2 },
  { 90, 0 },
  { 100, 0 },
  { 110, 0 },
  { 140, 1 },
  { 150, 0 },
  { 180, 0 },
  { 190, 2 },
  { 200, 1 },
  { 210, 0 },
  { 230, 3 },
  { 240, 2 },
  { 250, 2 },
  { 260, 2 },
  { 270, 3 },
  { 280, 3 },
  { 290, 3 },
  { 300, 3 },
  { 310, 3 },
  { 320, 3 },
  { 330, 2 },
  { 350, 2 },
  { 360, 2 },
  { 390, 3 },
  { 400, 3 },
  { 410, 3 },
  { 420, 0 },
  { 430, 2 },
  { 440, 2 },
  { 450, 2 },
  { 460, 2 },
  { 470, 2 },
  { 480, 2 },
  { 490, 2 },
  { 500, 2 },
  { 510, 2 },
  { 520, 2 },
  { 530, 2 },
  { 540, 2 },
  { 550, 2 },
  { 560, 2 },
  { 570, 2 },
  { 580, 2 },
  { 590, 2 },
  { 600, 2 },
  { 610, 0 },
  { 620, 2 },
  { 630, 2 },
  { 640, 0 },
  { 650, 2 },
  { 660, 0 },
  { 670, 0 },
  { 680, 2 },
  { 690, 2 },
  { 700, 2 },
  { 710, 2 },
  { 720, 2 },
  { 730, 0 },
  { 740, 1 },
  { 750, 1 },
  { 760, 0 },
  { 770, 1 },
  { 780, 1 },
  { 850, 0 },
  { 860, 2 },
  { 870, 2 },
  { 880, 0 },
  { 890, 2 },
  { 900, 0 },
  { 910, 0 },
  { 920, 0 },
  { 930, 2 },
  { 940, 1 },
  { 950, 0 },
  { 960, 1 },
  { 970, 0 },
  { 980, 0 },
  { 990, 2 },
  { 1000, 0 },
  { 1010, 0 },
  { 1020, 1 },
  { 1040, 2 },
  { 1050, 2 },
  { 1060, 2 },
  { 1070, 2 },
  { 1090, 3 },
  { 1100, 3 },
  { 1110, 3 },
  { 1120, 3 },
  { 1130, 3 },
  { 1140, 3 },
  { 1150, 3 },
  { 1160, 2 },
  { 1180, 2 },
  { 1190, 0 },
  { 1220, 2 },
  { 1240, 2 },
  { 1260, 2 },
  { 1270, 2 },
  { 1300, 3 },
  { 1320, 3 },
  { 1340, 3 },
  { 1350, 3 },
  { 1380, 2 },
  { 1390, 2 },
  { 1410, 2 },
  { 1420, 3 },
  { 1430, 0 },
  { 1450, 0 },
  { 1470, 0 },
  { 1480, 3 },
  { 1510, 0 },
  { 1530, 1 },
  { 1550, 0 },
  { 1560, 0 },
  { 1590, 0 },
  { 1600, 3 },
  { 1610, 0 },
  { 1620, 0 },
  { 1630, 0 },
  { 1640, 1 },
  { 1650, 2 },
  { 1660, 2 },
  { 1690, 3 },
  { 1700, 3 },
  { 1710, 0 },
  { 1730, 0 },
  { 1740, 0 },
  { 1770, 3 },
  { 1780, 3 },
  { 1790, 1 },
  { 1800, 2 },
  { 1830, 1 },
  { 1840, 1 },
  { 1870, 0 },
  { 1880, 1 },
  { 1890, 2 },
  { 1900, 2 },
  { 1910, 0 },
  { 1920, 1 },
  { 1950, 0 },
  { 1960, 0 },
  { 1990, 0 },
  { 2000, 0 },
  { 2030, 0 },
  { 2040, 1 },
  { 2070, 0 },
  { 2080, 1 },
  { 2090, 1 },
  { 2100, 2 },
  { 2110, 0 },
  { 2120, 2 },
  { 2130, 2 },
  { 2160, 2 },
  { 2170, 2 },
  { 2200, 3 },
  { 2210, 3 },
  { 2220, 2 },
  { 2230, 3 },
  { 2240, 0 },
  { 2250, 0 },
  { 2260, 0 },
  { 2270, 1 },
  { 2280, 0 },
  { 2290, 1 },
  { 2300, 1 },
  { 2320, 1 },
  { 2330, 0 },
  { 2360, 2 },
  { 2370, 2 },
  { 2380, 2 },
  { 2390, 0 },
  { 2400, 2 },
  { 2430, 2 },
  { 2440, 0 },
  { 2450, 0 },
  { 2460, 0 },
  { 2470, 2 },
  { 2500, 1 },
  { 2510, 1 },
  { 2520, 1 },
  { 2530, 1 },
  { 2540, 1 },
  { 2570, 2 },
  { 2580, 0 },
  { 2590, 0 },
  { 2600, 2 },
  { 2630, 0 },
  { 2640, 0 },
  { 2650, 2 },
  { 2660, 2 },
  { 2690, 0 },
  { 2700, 0 },
  { 2710, 0 },
  { 2720, 2 },
  { 2730, 0 },
  { 2740, 0 },
  { 2750, 0 },
  { 2760, 2 },
  { 2770, 1 },
  { 2780, 0 },
  { 2790, 1 },
  { 2800, 0 },
  { 2810, 1 },
  { 2840, 1 },
  { 2850, 1 },
  { 2880, 0 },
  { 2890, 1 },
  { 2920, 0 },
  { 2930, 0 },
  { 2960, 0 },
  { 2970, 0 },
  { 3000, 2 },
  { 3010, 2 },
  { 3040, 1 },
  { 3060, 1 },
  { 3080, 2 },
  { 3090, 0 },
  { 3100, 1 },
  { 3110, 1 },
  { 3130, 0 },
  { 3200, 2 },
  { 3210, 0 },
  { 3220, 2 },
  { 3230, 2 },
  { 3240, 1 },
  { 3250, 1 },
  { 3270, 1 },
  { 3280, 0 },
  { 3290, 2 },
  { 3300, 2 },
  { 3310, 0 },
  { 3320, 0 },
  { 3330, 1 },
  { 3331, 1 },
  { 3332, 2 },
  { 3340, 1 },
  { 3341, 1 },
  { 3342, 2 },
  { 3350, 0 },
  { 3360, 2 },
  { 3370, 2 },
  { 3390, 2 },
  { 3400, 2 },
  { 3410, 2 },
  { 3420, 2 },
  { 3430, 2 },
  { 3440, 2 },
  { 3441, 2 },
  { 3450, 2 },
  { 3451, 2 },
  { 3452, 2 },
  { 3460, 3 },
  { 3470, 2 },
  { 3480, 2 },
  { 3490, 2 },
  { 3500, 2 },
  { 3510, 2 },
  { 3520, 2 },
  { 3530, 2 },
  { 3540, 2 },
  { 3550, 0 },
  { 3551, 0 },
  { 3552, 1 },
  { 3560, 3 },
  { 3820, 2 },
  { 3830, 0 },
  { 3840, 2 },
  { 3850, 1 },
  { 3860, 1 },
  { 3870, 1 },
  { 3880, 1 },
  { 3890, 1 },
  { 3900, 1 },
  { 3910, 1 },
  { 3920, 2 },
  { 3930, 0 },
  { 3940, 0 },
  { 3950, 2 },
  { 3960, 0 },
  { 3970, 0 },
  { 3980, 0 },
  { 5390, 0 }
 },
 {
  { 10, 0 },
  { 20, 0 },
  { 30, 0 },
  { 40, 0 },
  { 50, 0 },
  { 60, 0 },
  { 70, 0 },
  { 80, 0 },
  { 90, 0 },
  { 100, 0 },
  { 110, 0 },
  { 140, 0 },
  { 150, 0 },
  { 180, 0 },
  { 190, 0 },
  { 200, 0 },
  { 210, 0 },
  { 230, 0 },
  { 240, 0 },
  { 250, 2 },
  { 260, 2 },
  { 270, 3 },
  { 280, 3 },
  { 290, 3 },
  { 300, 3 },
  { 310, 3 },
  { 320, 3 },
  { 330, 2 },
  { 350, 0 },
  { 360, 2 },
  { 390, 3 },
  { 400, 3 },
  { 410, 0 },
  { 420, 3 },
  { 430, 2 },
  { 440, 2 },
  { 450, 2 },
  { 460, 2 },
  { 470, 2 },
  { 480, 2 },
  { 490, 2 },
  { 500, 2 },
  { 510, 2 },
  { 520, 2 },
  { 530, 0 },
  { 540, 0 },
  { 550, 2 },
  { 560, 0 },
  { 570, 0 },
  { 580, 0 },
  { 590, 2 },
  { 600, 2 },
  { 610, 0 },
  { 620, 2 },
  { 630, 2 },
  { 640, 0 },
  { 650, 2 },
  { 660, 2 },
  { 670, 2 },
  { 680, 0 },
  { 690, 2 },
  { 700, 0 },
  { 710, 0 },
  { 720, 2 },
  { 730, 0 },
  { 740, 0 },
  { 750, 2 },
  { 760, 0 },
  { 770, 0 },
  { 780, 1 },
  { 790, 0 },
  { 800, 0 },
  { 810, 2 },
  { 820, 0 },
  { 830, 0 },
  { 840, 2 },
  { 850, 0 },
  { 860, 0 },
  { 870, 2 },
  { 880, 0 },
  { 890, 0 },
  { 900, 1 },
  { 910, 0 },
  { 920, 0 },
  { 930, 2 },
  { 940, 0 },
  { 950, 0 },
  { 960, 1 },
  { 1030, 2 },
  { 1080, 2 },
  { 1090, 3 },
  { 1100, 3 },
  { 1110, 3 },
  { 1120, 3 },
  { 1130, 3 },
  { 1140, 3 },
  { 1150, 3 },
  { 1160, 0 },
  { 1180, 2 },
  { 1190, 2 },
  { 1220, 2 },
  { 1240, 2 },
  { 1260, 2 },
  { 1270, 2 },
  { 1300, 0 },
  { 1320, 3 },
  { 1340, 3 },
  { 1350, 3 },
  { 1380, 3 },
  { 1390, 3 },
  { 1400, 3 },
  { 1420, 3 },
  { 1430, 0 },
  { 1450, 0 },
  { 1470, 0 },
  { 1480, 0 },
  { 1510, 1 },
  { 1530, 1 },
  { 1550, 0 },
  { 1560, 0 },
  { 1561, 0 },
  { 1562, 1 },
  { 1590, 3 },
  { 1600, 3 },
  { 1610, 0 },
  { 1620, 0 },
  { 1630, 2 },
  { 1640, 2 },
  { 1650, 2 },
  { 1660, 2 },
  { 1690, 3 },
  { 1700, 3 },
  { 1710, 2 },
  { 1730, 0 },
  { 1740, 2 },
  { 1770, 3 },
  { 1780, 3 },
  { 1790, 1 },
  { 1800, 1 },
  { 1830, 1 },
  { 1840, 1 },
  { 1870, 0 },
  { 1880, 1 },
  { 1890, 0 },
  { 1900, 3 },
  { 1910, 0 },
  { 1920, 0 },
  { 1950, 0 },
  { 1960, 0 },
  { 1990, 2 },
  { 2000, 0 },
  { 2030, 0 },
  { 2040, 2 },
  { 2070, 3 },
  { 2080, 1 },
  { 2090, 0 },
  { 2100, 3 },
  { 2110, 3 },
  { 2120, 2 },
  { 2130, 0 },
  { 2160, 2 },
  { 2170, 3 },
  { 2200, 0 },
  { 2210, 3 },
  { 2220, 3 },
  { 2230, 0 },
  { 2240, 0 },
  { 2250, 0 },
  { 2260, 2 },
  { 2270, 1 },
  { 2280, 0 },
  { 2290, 1 },
  { 2300, 1 },
  { 2320, 1 },
  { 2330, 1 },
  { 2360, 2 },
  { 2370, 0 },
  { 2380, 2 },
  { 2390, 2 },
  { 2400, 0 },
  { 2430, 0 },
  { 2440, 0 },
  { 2450, 2 },
  { 2460, 0 },
  { 2470, 2 },
  { 2500, 0 },
  { 2510, 1 },
  { 2520, 0 },
  { 2530, 1 },
  { 2540, 1 },
  { 2570, 3 },
  { 2580, 0 },
  { 2590, 2 },
  { 2600, 2 },
  { 2630, 2 },
  { 2640, 0 },
  { 2650, 0 },
  { 2660, 2 },
  { 2690, 0 },
  { 2700, 0 },
  { 2710, 2 },
  { 2720, 0 },
  { 2730, 0 },
  { 2731, 0 },
  { 2732, 2 },
  { 2740, 0 },
  { 2750, 0 },
  { 2760, 0 },
  { 2770, 1 },
  { 2780, 0 },
  { 2790, 0 },
  { 2800, 0 },
  { 2810, 1 },
  { 2840, 1 },
  { 2850, 1 },
  { 2880, 1 },
  { 2890, 0 },
  { 2920, 0 },
  { 2930, 0 },
  { 2960, 2 },
  { 2970, 0 },
  { 3000, 2 },
  { 3010, 2 },
  { 3040, 1 },
  { 3060, 1 },
  { 3080, 1 },
  { 3090, 0 },
  { 3100, 2 },
  { 3110, 1 },
  { 3130, 0 },
  { 3200, 2 },
  { 3210, 0 },
  { 3220, 0 },
  { 3221, 0 },
  { 3222, 1 },
  { 3230, 0 },
  { 3240, 2 },
  { 3250, 2 },
  { 3260, 2 },
  { 3280, 2 },
  { 3290, 2 },
  { 3300, 2 },
  { 3310, 0 },
  { 3320, 0 },
  { 3321, 0 },
  { 3322, 2 },
  { 3330, 2 },
  { 3340, 0 },
  { 3350, 2 },
  { 3360, 2 },
  { 3370, 2 },
  { 3380, 2 },
  { 3400, 0 },
  { 3410, 0 },
  { 3420, 2 },
  { 3430, 1 },
  { 3431, 1 },
  { 3432, 2 },
  { 3440, 2 },
  { 3441, 2 },
  { 3450, 2 },
  { 3451, 2 },
  { 3452, 2 },
  { 3460, 3 },
  { 3470, 0 },
  { 3480, 2 },
  { 3490, 0 },
  { 3500, 3 },
  { 3510, 2 },
  { 3520, 3 },
  { 3530, 2 },
  { 3540, 2 },
  { 3550, 2 },
  { 3560, 3 },
  { 3820, 3 },
  { 3830, 1 },
  { 3840, 0 },
  { 3850, 0 },
  { 3860, 0 },
  { 3870, 0 },
  { 3880, 0 },
  { 3890, 0 },
  { 3900, 0 },
  { 3910, 0 },
  { 3920, 1 },
  { 5390, 0 }
 },
 {
  { 10, 0 },
  { 20, 0 },
  { 30, 0 },
  { 40, 0 },
  { 50, 0 },
  { 60, 0 },
  { 70, 0 },
  { 80, 2 },
  { 90, 2 },
  { 100, 0 },
  { 110, 0 },
  { 140, 0 },
  { 150, 2 },
  { 180, 3 },
  { 190, 2 },
  { 200, 0 },
  { 210, 2 },
  { 230, 2 },
  { 240, 2 },
  { 250, 2 },
  { 260, 2 },
  { 270, 3 },
  { 280, 3 },
  { 290, 3 },
  { 300, 3 },
  { 310, 3 },
  { 320, 3 },
  { 330, 2 },
  { 350, 2 },
  { 360, 2 },
  { 390, 3 },
  { 391, 3 },
  { 400, 3 },
  { 410, 0 },
  { 420, 3 },
  { 430, 0 },
  { 440, 2 },
  { 450, 2 },
  { 460, 2 },
  { 470, 2 },
  { 471, 2 },
  { 472, 0 },
  { 480, 2 },
  { 490, 2 },
  { 500, 2 },
  { 510, 2 },
  { 520, 2 },
  { 530, 2 },
  { 540, 2 },
  { 550, 0 },
  { 560, 2 },
  { 570, 2 },
  { 580, 0 },
  { 590, 2 },
  { 600, 2 },
  { 610, 2 },
  { 620, 0 },
  { 630, 2 },
  { 640, 0 },
  { 650, 0 },
  { 660, 2 },
  { 670, 0 },
  { 680, 0 },
  { 690, 2 },
  { 700, 2 },
  { 710, 2 },
  { 720, 2 },
  { 730, 2 },
  { 740, 2 },
  { 750, 2 },
  { 760, 2 },
  { 770, 0 },
  { 780, 0 },
  { 790, 0 },
  { 800, 0 },
  { 810, 2 },
  { 820, 2 },
  { 830, 2 },
  { 840, 2 },
  { 850, 2 },
  { 860, 2 },
  { 870, 2 },
  { 880, 0 },
  { 890, 2 },
  { 900, 0 },
  { 970, 2 },
  { 980, 2 },
  { 990, 2 },
  { 1000, 2 },
  { 1010, 0 },
  { 1020, 2 },
  { 1030, 2 },
  { 1080, 2 },
  { 1090, 3 },
  { 1100, 3 },
  { 1110, 3 },
  { 1120, 3 },
  { 1130, 3 },
  { 1140, 3 },
  { 1150, 3 },
  { 1160, 2 },
  { 1180, 2 },
  { 1190, 2 },
  { 1220, 2 },
  { 1240, 2 },
  { 1260, 2 },
  { 1270, 2 },
  { 1300, 3 },
  { 1320, 3 },
  { 1340, 3 },
  { 1350, 3 },
  { 1380, 3 },
  { 1390, 3 },
  { 1400, 3 },
  { 1410, 3 },
  { 1430, 0 },
  { 1450, 0 },
  { 1470, 2 },
  { 1480, 2 },
  { 1510, 3 },
  { 1530, 1 },
  { 1550, 1 },
  { 1560, 1 },
  { 1590, 3 },
  { 1600, 3 },
  { 1610, 0 },
  { 1620, 0 },
  { 1630, 0 },
  { 1640, 2 },
  { 1650, 2 },
  { 1660, 2 },
  { 1690, 3 },
  { 1700, 3 },
  { 1710, 2 },
  { 1730, 2 },
  { 1740, 2 },
  { 1770, 3 },
  { 1780, 3 },
  { 1790, 0 },
  { 1800, 1 },
  { 1830, 1 },
  { 1840, 1 },
  { 1870, 0 },
  { 1880, 1 },
  { 1890, 2 },
  { 1900, 2 },
  { 1910, 0 },
  { 1920, 0 },
  { 1950, 0 },
  { 1960, 0 },
  { 1990, 2 },
  { 2000, 2 },
  { 2030, 0 },
  { 2040, 0 },
  { 2070, 2 },
  { 2080, 0 },
  { 2090, 1 },
  { 2100, 2 },
  { 2110, 3 },
  { 2120, 2 },
  { 2130, 2 },
  { 2160, 2 },
  { 2170, 2 },
  { 2200, 3 },
  { 2210, 3 },
  { 2220, 2 },
  { 2230, 3 },
  { 2240, 0 },
  { 2250, 0 },
  { 2260, 3 },
  { 2270, 0 },
  { 2280, 1 },
  { 2290, 0 },
  { 2300, 1 },
  { 2320, 0 },
  { 2330, 1 },
  { 2360, 0 },
  { 2370, 0 },
  { 2380, 2 },
  { 2390, 0 },
  { 2400, 0 },
  { 2430, 1 },
  { 2440, 0 },
  { 2450, 0 },
  { 2460, 0 },
  { 2470, 2 },
  { 2500, 1 },
  { 2510, 1 },
  { 2520, 0 },
  { 2530, 1 },
  { 2540, 1 },
  { 2570, 3 },
  { 2580, 2 },
  { 2590, 2 },
  { 2600, 0 },
  { 2630, 3 },
  { 2640, 2 },
  { 2650, 2 },
  { 2660, 2 },
  { 2690, 3 },
  { 2700, 2 },
  { 2710, 0 },
  { 2720, 2 },
  { 2730, 2 },
  { 2740, 0 },
  { 2750, 2 },
  { 2760, 0 },
  { 2770, 1 },
  { 2780, 0 },
  { 2790, 1 },
  { 2800, 1 },
  { 2810, 0 },
  { 2840, 0 },
  { 2850, 1 },
  { 2880, 1 },
  { 2890, 1 },
  { 2920, 0 },
  { 2930, 0 },
  { 2960, 2 },
  { 2970, 2 },
  { 3000, 2 },
  { 3010, 3 },
  { 3040, 0 },
  { 3060, 1 },
  { 3080, 0 },
  { 3090, 2 },
  { 3100, 1 },
  { 3110, 1 },
  { 3130, 2 },
  { 3200, 2 },
  { 3210, 0 },
  { 3220, 2 },
  { 3230, 2 },
  { 3240, 2 },
  { 3250, 2 },
  { 3251, 2 },
  { 3252, 0 },
  { 3260, 2 },
  { 3270, 2 },
  { 3271, 2 },
  { 3272, 0 },
  { 3290, 0 },
  { 3300, 0 },
  { 3310, 3 },
  { 3320, 0 },
  { 3330, 0 },
  { 3340, 2 },
  { 3341, 2 },
  { 3342, 0 },
  { 3350, 0 },
  { 3360, 0 },
  { 3370, 0 },
  { 3380, 0 },
  { 3390, 0 },
  { 3410, 0 },
  { 3420, 2 },
  { 3430, 0 },
  { 3440, 2 },
  { 3441, 2 },
  { 3450, 2 },
  { 3451, 2 },
  { 3452, 2 },
  { 3460, 3 },
  { 3470, 0 },
  { 3480, 2 },
  { 3490, 2 },
  { 3500, 0 },
  { 3510, 2 },
  { 3520, 0 },
  { 3530, 0 },
  { 3540, 2 },
  { 3550, 2 },
  { 3560, 3 },
  { 3820, 2 },
  { 3830, 0 },
  { 3840, 3 },
  { 3850, 2 },
  { 3860, 3 },
  { 3870, 0 },
  { 3880, 2 },
  { 3890, 2 },
  { 3900, 1 },
  { 3910, 0 },
  { 3920, 2 },
  { 3930, 2 },
  { 3940, 2 },
  { 3950, 0 },
  { 3960, 2 },
  { 3970, 2 },
  { 3980, 0 },
  { 3990, 0 },
  { 4000, 2 },
  { 4010, 0 },
  { 4020, 2 },
  { 4030, 2 },
  { 4031, 2 },
  { 4032, 0 },
  { 4040, 2 },
  { 5390, 0 }
 }
}
G_TENSION_MAX = false
function STAGE_RESET()
 KeyPress( 1, 9 )
 Special( "INVALIDATE_GIMMICK", 0 )
 SetSystemVar(11, 0)
 SetSystemVar(12, 0)
 SetSystemVar(13, 0)
 SetSystemVar(14, 0)
 SetSystemVar(15, 0)
 SetSystemVar(41, 0)
 SetSystemVar(42, 0)
 SetSystemVar(43, 0)
 SetSystemVar(44, 0)
 SetSystemVar(45, 0)
 SetSystemVar(21, 0)
 SetSystemVar(22, 0)
 if ( GetUnitInfo( "@MPR_Player_1_0", 51 ) < 1.0 ) then
  AddEventTrigger( "TENSION_MAX", 99, "TENSIONMAX" )
  G_TENSION_MAX = true
 end
end
G_TUTORIAL = {
 {
  "",
  "アイテム",
  "ステージに存在するアイテムの説明を行います\n説明はSTARTボタンでスキップできます"
 },
 {
  "",
  "ＨＰ回復",
  "触れるとＨＰが回復します\nアイテムの大きさが大きいほど効果もあがります"
 },
 {
  "",
  "ＭＰ回復",
  "触れるとＭＰが回復します\nアイテムの大きさが大きいほど効果もあがります"
 },
 {
  "",
  "テンションアップ",
  "触れるとテンションゲージが上がります\nアイテムの大きさが大きいほど効果もあがります"
 },
 {
  "",
  "制限時間追加",
  "触れるとステージの制限時間が追加されます\nアイテムの大きさが大きいほど効果もあがります"
 },
 {
  "",
  "扉",
  "触れると次の階層に進みます\n扉は画面右上のミニマップに表示されます"
 }
}
AddEventTrigger( "BATTLESTART", 10, "PASSSEC", "GAMESTART", 0 )
AddEventTrigger( "CHANGE_TARGETDISTANCE_1", 20, "DURAB", "ANYBODY", "@MPR_Enm_MS_S_PYOTR2_PRO_0", 99, "||",
            "DURAB", "ANYBODY", "@MPR_Enm_MS_S_PYOTR1_PRO_0", 99, "||",
            "DURAB", "ANYBODY", "@MPR_Enm_MS_S_PYOTR1_PRO_1", 99, "||",
            "DURAB", "ANYBODY", "@MPR_Enm_MS_S_PYOTR1_PRO_2", 99, "||",
            "DURAB", "ANYBODY", "@MPR_Enm_MS_S_PYOTR1_PRO_3", 99, "||",
            "MOVEIN", "@MPR_Player_1_0", 160, 210, 220, 300 )
AddEventTrigger( "APPEAR_ENEMY_1", 19, "VANISH", 0, 1, -1 )
AddEventTrigger( "APPEAR_DROP_ITEM", 20, "VANISH", 0, 2, -1 )
AddEventTrigger( "APPEAR_ENEMY_2", 20, "VANISH", 0, 100, -1 )
AddEventTrigger( "APPEAR_ENEMY_3", 20, "ENTDIS", "@MPR_Enm_MS_S_NURSE1_PRO_0", "@MPR_Player_1_0", 50, "||",
            "DURAB", "ANYBODY", "@MPR_Enm_MS_S_NURSE1_PRO_0", 99 )
AddEventTrigger( "APPEAR_ENEMY_4", 20, "ENTDIS", "@MPR_Enm_MS_S_NURSE1_PRO_1", "@MPR_Player_1_0", 50, "||",
            "DURAB", "ANYBODY", "@MPR_Enm_MS_S_NURSE1_PRO_1", 99 )
AddEventTrigger( "OPEN_DOOR_10", 10, "VANISH", 0, 1, -1, "&&",
            "VANISH", 0, 2, -1, "&&",
            "VANISH", 0, 3, -1, "&&",
            "VANISH", 0, 4, -1, "&&",
            "VANISH", 0, 5, -1, "&&",
            "VANISH", 0, 6, -1, "&&",
            "VANISH", 0, 10, -1 )
function BATTLESTART()
 STAGE_RESET()
 SetLimitTime( 3600 )
 CreateUnit( 1, 1 )
 CreateUnit( "@MPR_Enm_MS_S_PYOTR2_PRO_0" )
 DEMO_STAGE_START( {
      { -170, 5, -230, 75 },
      { 80, 5, 180, 10 },
      { 380.474,67.645,279.427 }
       } )
 MessageAI(1, "1", 0.0)
 ROOM_IN( 1, "すべての使い魔を倒せ！" )
end
function CHANGE_TARGETDISTANCE_1()
 CreateUnit( "@MPR_UGen_OB_UNITGENERATOR_0" )
 MessageAI( 1, "1", 500.0 )
end
function APPEAR_ENEMY_1()
 CreateUnit( 2 )
 EVENT_APPEAR_ENEMY_NORMAL()
end
function APPEAR_DROP_ITEM()
 local look_y = 0
 local unit = { "@MPR_DropItem_OB_ITEM_HP_03_0",
       "@MPR_DropItem_OB_ITEM_MP_03_0",
       "@MPR_DropItem_OB_ITEM_TG_02_0",
       "@MPR_DropItem_OB_ITEM_TM_02_0" }
 Special( "BLOCK_PAUSEMENU", 1 )
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  for i = 1, table.maxn( unit ) do
   ResetTime()
   CreateUnit( unit[i] )
   if ( i > 1 ) then
    DeleteUnit( unit[i-1], 0 )
   end
   if ( i == 1 ) then
    look_y = 7
   elseif ( i == 2 ) then
    look_y = 10
   elseif ( i == 3 ) then
    look_y = 16
   elseif ( i == 4 ) then
    look_y = 12
   else
    look_y = 11
   end
   Path( 3, 6, 45, 43, 0, 1.6 )
   Path( 2, 5, 0, 0, 0, 10 )
   Path( 0, 0, "PARENT_Y", unit[i], 0, look_y, 0 )
   Path( 1, 2, "PARENT_Y", unit[i],
      0, 11, 0,
      0, 0, 42,
      0, 0, 0,
      0, 0, 0,
      0, 0, 0 )
   _retry( WaitTime, 1/30 )
   Path( 0, 0,
      GetWorldInfo( 3 ),
      GetWorldInfo( 4 ),
      GetWorldInfo( 5 ) )
   Path( 1, 0,
      GetWorldInfo( 0 ),
      GetWorldInfo( 1 ),
      GetWorldInfo( 2 ) )
   if ( i <= 1 ) then
    subCutin( { obj="@MPR_Player_1_0", voice={ 1870, 1880 } } )
    subDeleteCutin()
    SeStop( -1 )
    _retry( WaitTime, 1/30 )
    SePlay( "SEID_STG_JINGLE_PLUS" )
    SePlay( "SEID_STG_APPEAR_DROPITEM" )
    _retry( EQWait )
    _retry( WaitTime, 0.5 )
    subTextTutorialInDemo( G_TUTORIAL, i, "NEXT" )
    subTextTutorialInDemo( G_TUTORIAL, i + 1, "LAST" )
   else
    _retry( WaitTime, 1.6 )
    subTextTutorialInDemo( G_TUTORIAL, i + 1 )
   end
  end
  subAfterDemo()
  EndDemo()
 end
 DeleteText()
 CreateUnit( 100, 1 )
 _retry( WaitTime, 0.1 )
 Special( "BLOCK_PAUSEMENU", 0 )
end
function APPEAR_ENEMY_2()
 CreateUnit( 3 )
 CreateUnit( 5 )
 MessageAI( 3, "1", 0.0 )
 MessageAI( 5, "1", 0.0 )
 EVENT_APPEAR_ENEMY_NORMAL()
end
function APPEAR_ENEMY_3()
 CreateUnit( 4 )
 Locate( "@MPR_Enm_MS_S_PYOTR1_PRO_6", "PARENT_Y", "@MPR_Enm_MS_S_NURSE1_PRO_0", 0, 100+Rand(100), -30, 0, 0 )
 Locate( "@MPR_Enm_MS_S_PYOTR2_PRO_3", "PARENT_Y", "@MPR_Enm_MS_S_NURSE1_PRO_0", 30, 100+Rand(100), 0, 0, 0 )
 Locate( "@MPR_Enm_MS_S_PYOTR2_PRO_4", "PARENT_Y", "@MPR_Enm_MS_S_NURSE1_PRO_0", -30, 100+Rand(100), 0, 0, 0 )
 MessageAI(3, "1", 500.0)
 EVENT_APPEAR_ENEMY_NORMAL()
end
function APPEAR_ENEMY_4()
 CreateUnit( 6 )
 Locate( "@MPR_Enm_MS_S_PYOTR1_PRO_5", "PARENT_Y", "@MPR_Enm_MS_S_NURSE1_PRO_1", 0, 100+Rand(100), -30, 0, 0 )
 Locate( "@MPR_Enm_MS_S_PYOTR2_PRO_1", "PARENT_Y", "@MPR_Enm_MS_S_NURSE1_PRO_1", 30, 100+Rand(100), 0, 0, 0 )
 Locate( "@MPR_Enm_MS_S_PYOTR2_PRO_2", "PARENT_Y", "@MPR_Enm_MS_S_NURSE1_PRO_1", -30, 100+Rand(100), 0, 0, 0 )
 MessageAI(5, "1", 500.0)
 EVENT_APPEAR_ENEMY_NORMAL()
end
function OPEN_DOOR_10()
 local unit = "@MPR_Door_OB_CHAR_DOOR_02_0"
 local cam = { 14.5, 14.5, 56 }
 local hp = { GetUnitInfo( "@MPR_Player_1_0", 0 ),
     GetUnitInfo( "@MPR_Player_2_0", 0 ) }
 local rotate = { 1, 1 }
 for i = 1, table.maxn( rotate ) do
  if ( Rand(2) == 0 ) then rotate[i] = -1 end
 end
 _retry( EQDelete )
 EndHomuraTimeStop()
 _retry( WaitTime, 1/30 )
 if ( BeginDemo() ) then
  subBeforeDemo()
  CamFar( 20000 )
  CreateUnit( unit )
  Path( 3, 6, 45, 42, 0, 4 )
  Path( 2, 5, 0, 0, 0, 10 )
  Path( 0, 0, "PARENT_Y", unit, 0, cam[1], 0 )
  Path( 1, 2, "PARENT_Y", unit,
     0, cam[2], 0,
     0, 0, cam[3],
     0, 0, 0,
     0, 0, 0,
     0, 0, 0 )
  TALK_APPEAR_DOOR( unit, true, hp )
  SeStop( -1 )
  _retry( WaitTime, 1/30 )
  SePlay( "SEID_STG_JINGLE_DOOR" )
  SePlay( "SEID_STG_DOOR_APPEAR" )
  _retry( WaitElapsedTime, 4 )
  _retry( EQWait )
  subTextTutorialInDemo( G_TUTORIAL, 6 )
  subAfterDemo()
  EndDemo()
 end
 DeleteText()
 CreateUnit( unit, 1 )
end
